C DOSNAME.FOR
C Dateiname im Format 8.3 fr DOS darstellen
C
C Autor   : Uwe Bhnke, Hannover
C Erstellt: 11.12.2013
C Stand   : 19.02.2024
C
C Eingabe des Namens als Kommandozeilenparameter oder in DOSNAME.EIN
C Verwende nicht c:\name.ein, da "Zugriff verweigert" erfolgen kann
C Zwischenspeicherung in C:\TEMP\Z
C Ausgabe des DOS-konformen 8.3-Namens in DOSNAME.AUS
C
C Option: /1 ohne Bildschirmausgabe (leise)
C Option: /2 Dateiname mit Pfad, sonst nur Dateiname
C Option: /x verwende dir/x statt dir /-n
C Option: /2k Option fr Windows 2000 oder NT4
C
C Bentigt unbedingt CMD.EXE, da dir/-n nur mit CMD funktioniert
C Verwende C:\TEMP\Z statt C:\TEMP\DOSNAME.TMP -> der String wird kurz
C Verwende nicht Z sonst wird er in der Digitale Akte abgelegt
C DOSNAME funktioniert normal fr Dateien;
C Ein Verzeichnis muss mit einem Stern am Ende bergeben werden.
C Ein Dateiname/Verzeichnisname mit Leerzeichen muss in " eingeschlossen
C werden. Der * kann innerhalb oder auerhalb stehen.
C
      program dosname
      integer*2 nblank,letzt,i,j,k
      character *128 param,datei,name
      character *80 befehl
      logical ok,leise,pfad,hid,px
C  Lesen des DOSNAME aus der Kommandozeile
C  Wenn nicht angegeben, lesen aus Datei DOSNAME.EIN
      datei=' '
      leise=.false.
      pfad=.false.
      hid=.false.
      px=.false.
      call getcl (param)

      if (index(param,'/1').gt.0) leise=.true.
      if (index(param,'/2').gt.0) pfad=.true.
      if (index(param,'/ah').gt.0) hid=.true.
      if (index(param,'/?').gt.0) then
        call system ('type DOSNAME.DOK')
        call pause
        stop
      end if

      if (.not.leise) write (*,*) ' DOSNAME - ermittelt 8.3-Name'

      if (param(1:1).eq.' ') param=param(2:)
      datei=param
      i=index(datei,'/')
      if (i.gt.0) datei(i:)=' '

      if (datei.eq.' ') then
        if (.not.leise) write (*,*) ' Lese DOSNAME.EIN'
        inquire (file='DOSNAME.EIN',exist=ok)
        if (ok) then
          open (10,file='DOSNAME.EIN')
          read (10,'(A)',end=90) datei
90        close (10)
        else
          write (*,*) ' Dateiname:'
          read (*,'(A)',end=91) datei
91      end if
      end if

      if (datei.eq.' ') then
        if (.not.leise) then
          write (*,*) ' Keinen Dateinamen angegeben.'
          write (*,*) ' /1 ohne Bildschirmausgabe (leise)'
          write (*,*) ' /2 Dateiname mit Pfad, sonst nur Dateiname'
          write (*,*) ' /x verwende dir/x statt dir /-n'
          write (*,*) ' /2k Option fr Windows 2000 oder NT4'
          call pause
        end if
        stop
c      else
c        if (index(param,'/x').eq.0) then
c          write (*,*) ' Standard: dir/-n. Statt dessen dir/x (J/N)?'
c          call askjn (*95)
c          px=.true.
c95      end if
      end if
C  DOSNAME wird zunchst mit dem ursprnglichen Namen gleichgesetzt
      name=datei

C  Folgendes bewirkt Rcksprung ohne nderung bei 8.3-Namen #1
c     i=index(datei,'.')
c     j=nblank(datei)
c     if (j.le.8.or.j.le.12.and.j-i.le.3) goto 99
C  Folgendes bewirkt Rcksprung ohne nderung bei 8.3-Namen #2
      i=index(name,' ')
      j=index(name,'.')
      k=nblank(name)
      if ((i.eq.0.or.i.gt.k)
     *.and.(j.eq.0.and.k.le.8.or.j.gt.0.and.j.le.9.and.k-j.le.3)
     *.and.k.le.12) goto 99
C  Folgendes bewirkt Rcksprung ohne nderung bei 8.3-Namen #3
C  Dies scheint doch keine einfache Methode zu sein, 8.3-Namen zu
C  erkennen
c     inquire (file=datei,exist=ok)
c     if (ok) goto 99

C  Wenn DOSNAME kurz genug, zurck
C  (nur fr DRUCKEN, nicht fr AUSWAHL, da der PFAD ebenfalls zu lang
C  sein knnte und daher DOS-gerecht gekrzt werden muss)
c     i=letzt(datei,'\')
c     j=index(datei,'.')
c     if (nblank(datei)-i.le.12) then
c       if (j.eq.0.and.nblank(datei)-i.le.8
c    *  .or.j.gt.0.and.(nblank(datei)-j.le.3.and.j-i.le.8)) then
c         goto 99
c       end if
c     end if

C  "dir" fr DOSNAME

100   if (px.or.index(param,'/x').gt.0) then
        befehl='cmd/c dir/x'
        if (hid) befehl(13:)='/ah'
      else
        befehl='cmd/c dir/-n'
        if (hid) befehl(14:)='/ah'
      end if
      befehl(nblank(befehl)+2:)=datei
      befehl(nblank(befehl)+1:)='>c:\temp\z'
c     print *,befehl
c     print *,nblank(befehl)
C  Die Anzahl 78 ist getestet
      if (nblank(befehl).gt.78) goto 99
      call system (befehl)

C  DIR-Ausgabe lesen
      open (10,file='c:\temp\z')
      befehl=' '
      do while (befehl(1:1).eq.' ')
        read (10,'(A)',end=97) befehl
      end do
97    close (10)
      if (befehl.eq.' ') goto 99

C  Den Punkt ergnzen (wie in: filename.ext)
C  Der Punkt ist fr Dateien erforderlich, fr Verzeichnisse nicht,
C  strt da aber nicht, bleibt also
c     i=index(befehl,' ')
c     befehl(i+1:)=befehl(10:12)
c     if (befehl(i+1:).ne.' ') befehl(i:i)='.'
C  oder:
c     i=index(befehl,' ')
c     if (i.lt.nblank(befehl)) then
c       befehl(i+1:)=befehl(10:12)
c       befehl(i:i)='.'
c     end if

C  DOSNAME zuordnen
C  Entweder mit Pfad
      if (pfad) then
        name=datei(1:letzt(datei,'\'))
        name(nblank(name)+1:)=befehl
C  oder ohne Pfad
      else
C  Version mit dir /x
        if (px.or.index(param,'/x').gt.0) then
          name=' '
          if (index(param,'/2k').gt.0) then
            name=befehl(40:51)
          else
            name=befehl(37:48)
          end if
C  Version mit dir /-n
        else
          name=befehl(1:12)
        end if
c  Ende entweder
      end if

C  Ausgabe
      if (.not.leise) write (*,*) ' Schreibe DOSNAME.AUS'
99    open (10,file='DOSNAME.AUS')
      write (10,'(A)') name
      close (10)
C  Abfrage bergehen wenn leise
      if (.not.leise) then
        if (name.eq.' ') write (*,*) ' Kein DOSNAME ermittelbar.'
        print *,name
        if (index(param,'/x').gt.0) then
          call pause
C  Variante mit /x
        else
          write (*,*) ' Ausgabe mit dir/x (J/N)?'
          call askjn (*95)
          px=.true.
          goto 100
95      end if
      end if
      stop
      end
C
C  Das letzte Vorkommen eines Zeichens finden
C
      function letzt (wert,zeichen)
      character *(*) wert
      character*1 zeichen
      integer*2 letzt,nblank,i
      letzt=0
      i=nblank(wert)
      do while (wert(i:i).ne.zeichen.and.i.gt.0)
        i=i-1
      end do
      letzt=i
      return
      end
