C  DOSWAHL.FOR
C
C  NUR fr kurze Dateinamen (8.3=12 Zeichen)
C  Darstellung zweispaltig. Nur ein Datenfeld.
C
C  Unterschied von DOSWAHL.EXE zur Dateiauswahl AUSWAHL.EXE:
C
C  - lange Dateinamen werden per dir/-n gekrzt ausgegeben,
C     damit aufrufende DOS-Programme die Datei auch ffnen knnen
C (- Zweispaltige Darstellung mglich zwecks Vergleich z.B. fr)
C     zwei verschiedene Ordner oder verschiedene Dateitypen
C  - Die Anzeige von Dateien in verschiedenen Unterverzeichnissen
C     gleichzeitig (nach ALT-F7 oder nach FINDEN) funktioniert
C     so nicht, 12 Zeichen gengen nicht.
C  - CMD wird ignoriert
C  - Strg-F12 fr Wechsel CMD und COMMAND deaktiviert
C  - dlaenge=12 (statt 51)
C  - zmax=2170 (statt 900)
C  - Function DOSNAME und ihre Aufrufe deaktiviert
C  - character*51 ersetze durch *12 fr diverse Variablen
C
C  Dateiauswahl fr REKO, EINGABE, SUCHEN, PROG
C
C  Das Dateikriterium von Kommandozeilenparameter wird
C  direkt verwendet, um das LW. und das Verz. zu wechseln;
C  in LESEDATEN wird grundstzlich nur vom aktuellen Verz. gelesen
C  und daraus dann der Name des Verz. aus DIR ausgelesen.
C
C  Aus den im Parameter angegebenem Dateikriterium mit oder ohne
C  Verzeichnisangabe wird die Verzeichnisdatei DIR.TMP mit
C  dem Befehl "DIR verz /ogn /-p" erstellt, die dann gelesen wird.
C  Auf diese Weise werden, nach Namen sortiert, zuerst die
C  Unterverzeichnisse und dann die Dateien angezeigt.
C
C  Kann merkfind durch merkdate ersetzt werden? Nein, da merkfind fr
C  STRG-F und Parameter /F: verwendet wird. Die gesuchte Datei muss nur
C  zum Teil mit merkfind bereinstimmen, aber ganz mit merkdate.
C
C  Erforderlich:
C
C  -> Mathematischer Co-Prozessor
C  -> DEVICE=ANSI.SYS fr Farbsetzung und Cursor-Positionierung
C  -> MS-DOS ab Version 5.0 fr DIR-Parameter
C  -> MS-Windows NT4, 2000, XP, Vista, Win7 (32bit)
C
C  Das Programm ist auch mit mehr als ZMAX Dateien kompilierbar;
C  aber bei Aufruf einer Funktion kann dann STACK OVERFLOW eintreten.
C
C  Auf Grund der 64kbit-Grenze des Compilers/Linkers muss der Quelltext
C  mglichst gleichmig auf Hauptprogramm und Unterprogramme verteilt
C  werden. Daher gibt es Quelltext, den ich ansonsten lieber in ein
C  Unterprogramm verschoben htte; so aber gibt es mehr Funktionen.
C
C  Definitionen
C
C  Logische Variablen: "0" = .FALSE., "1" = .TRUE.
C
C  aktfile : aktuelle Datei ggf. mit Laufwerk und Pfad
C  altm    : zuletzt gltige Cursorposition (fr das Scrollen)
C  altmin  : zuletzt gltige Anfangsmarke
C  anzahl  : Anzahl der pro Bildschirm angezeigten Dateien
C  anzmkt  : Anzahl der markierten Dateien
C  befehl  : Befehl, der mit system() auszufhren ist
C  belege  : Belege-Ordner gem REKO.INI #BELEGE
C  datei   : aktuelle Datei ohne Laufwerk oder Verzeichnis
C  dlaenge : maximale Lnge eines Dateinamens ohne Datum, Zeit, Gre
C            WICHTIG: in FINDEN.EXE ab Zeile 200 anpassen!
C  digi    : Digitale Akte
C  dbverz  : C:\EINGABE, Transferverzeichnis von und fr SIR
C  editor  : Name eines Editors, z.B. NOTEPAD, KEDIT, EDIT
C  fall    : Fallnummer (normalerweise 8-stellig)
C  farbe   : Bildschirm-Vorder- und Hintergrundfarbe (ANSI.SYS-Befehl)
C  fmark   : Farbe fr die Editierbare Eingabezeile ("input")
C  files   : Dateikriterium, z.B. *.for oder 0601*.*
C [form    : Formatanweisung fr Datei- und Verzeichnisdarstellung]
C  graphik : =1 wenn REKO-Graphik erlaubt
C  grkl    : =1 wenn Gro/Kleinschreibweise beachtet werden soll
C  hid     : =0 normal, =1 versteckte Dateien anzeigen (/ah)
C  i       : laufende Nummer der Datei
C  imax    : Anzahl aller Dateien des angezeigten Verzeichnisses
C  isa     : Funktionstatsten =0 F?; =1 Alt-F?; =2 Shift-F?; =3 Strg-F?
C [isb     : wenn Parameter /8:xxx angegeben, Aufruf von beginn(xxx)
C  ISB deaktiviert, da es in REKO, EINGABE zu viele Aufrufe von
C  AUSWAHL.EXE gibt, so dass dort wieder Kapazittsprobleme enstehen,
C  wenn der Befehl um /8:xxx erweitert werden muss.]
C  isn     : =0 DIR.TMP erstellen/lesen,=1 DIR.TMP nur lesen:
C            Verwendung intern, und extern durch den Parameter "/2"
C  iso     : =0 Sortierung vorwrts,    =1 Sortierung rckwrts
C  isp     : =0 bei direktem Aufruf,    =1 bei Aufruf mit "/1"
C            =0 "mode con lines=xx" ausfhren,    =1 wenn nicht
C  isv     : =0 aktuelle Datei ist Datei,  =1 Verzeichnis
C  isvneu  : =0 zu erstellende Datei,   =1 zu erstellendes Verzeichnis
C  key     : ASCII-Code der gedrckten Taste (2-Byte-Code: 1000+2.Byte)
C  marke   : aktuelle Positionsnummer
C  maxmarke: Nummer der letzten auf Bildschirm angezeigten Datei
C  minmarke: Nummer der ersten  auf Bildschirm angezeigten Datei
C  merkdate: gemerkter Name der zuletzt aktuellen Datei
C  merkfind: gemerkter Text fr die Dateisuchfunktion Strg-F ("schnell")
C            und Datei-Suche mit Alt-F7
C  merkziel: gemerktes Ziel fr das Kopieren
C  merkmark: gemerktes Kriterium zum Markieren oder Demarkieren (+,-)
C  merkverz: gemerktes Verzeichnis fr den Rcksprung
C  merkkrit: gemerktes Dateikriterium
C  mkt     : Markierung (Sternchen) einer Datei fr eine Aktion
C  opt     : Optionen fr DIR bei Programmstart (z.B. /s/b)
C  param   : Kommandozeilenparameter: Dateien mit LW:\VERZ
C  pparam  : Kommandozeilenparameter fr aufgerufenes Programm
c  parf    : =1 Parameter /F: angegeben, d.h nur einmal suchen
C  prn     : Anschlu des Druckers
C  rec     : Typ des Records aus der aktuellen Datei
C  reko    : Name des aktuellen Verzeichnisses
C  sort    : Option fr Sortierung (DIR-Parameter)
c  strgf9  : Suchtext fr Strg-F9 (Darstellungsfilter)
c  tab     : ='01' fr Dateianzeige links, '41' fr Dateianzeige rechts
c  team    : Laufwerk und Verzeichnis des Team-Ordners (T:)
C  typ     : Typ der Rekonstruktion, also KA,FG,OB,VB,EP,SP.
C  top     : Nummer der Bildschirmzeile der ersten Datei
C  verz    : aktuelles Laufwerk und Verzeichnis ohne Dateikriterium
C  weiter  : Weitersuchen bei Schnellsprung, wenn nicht gefunden
C  xcopy   : Option /-Y fr XCOPY.EXE
C            Diese Variable kann bei Kapazittsproblemen weggelassen
C            werden, da sie eigentlich nicht bentigt wird
C  zeilen  : Anzahl der Bildschirmzeilen (25, 43 oder 50)
C  zmax    : zulssige (kompilierbare) Anzahl Dateien
C  zurueck : =1 merkt sich das Verz.; dann mit ESC zurck statt Ende
C  zurueck2: =1 merkt sich die Liste; dann mit ESC zurck statt Ende
C  zwdatei : gemerkter Dateiname fr die Clipboard-Funktion STRG-C,V,X
C            und zweite Datei fr Strg-F6, Shift-F6
C  zwpfad  : Ordner der mit STRG-C markierten Dateien
C
      program DOSWAHL
c     implicit none
      integer*2 zmax,dlaenge,isa
C  Folgendes nur fr DOSWAHL:
      parameter (dlaenge=12,zmax=2180)
      integer*2 i,j,imax,marke,minmarke,maxmarke,altm,altmin,
     *key,ixkey,zeilen,nblank,anzahl,anzmkt,alt,mrk,letzt,top,jahr
c     isb
      logical isn,isp,isv,hid,ok,zurueck,zurueck2,
     *graphik,iso,isvneu,weiter,parf
c    *dir,isvneu,grkl
      character *1 mkt(zmax),ch1,ch2
      character *2 typ,rec
      character *2 tab
c     character *3 xcopy
      character *5 sort,altsort
      character *5 farbe,fmark
      character *8 fall,opt
      character *12 merkfind,strgf9,files,merkkrit,merkmark,aktfile,
     *merkdate,zwdatei
      character *51 dbverz,digi,belege,prn,reko,team,verz,merkverz,
     *zwpfad,merkziel
      character *78 befehl
      character *80 param
      character *128 text,upper
c     character *128 temp
      character *8 datum(zmax)
c     character *5 zeit(zmax)
      integer*2 zeit1(zmax),zeit2(zmax)
      character *(dlaenge) datei(zmax)
      integer bytes(zmax)

C  Initialisierung
      aktfile=' '
      altmin=1
      altm=1
      anzmkt=0
      belege=' '
      datei(1)=' '
      digi=' '
c     dir=.false.
c     editor='notepad'
      files='*.*'
      farbe='7'
      fmark='44;37'
      hid=.FALSE.
      imax=0
      isa=0
c     isb=0
      isv=.false.
      key=0
      merkziel=' '
      minmarke=1
      marke=1
      merkdate=' '
      merkfind=' '
      merkkrit=' '
      merkmark=' '
      merkverz=' '
      opt=' '
      parf=.false.
      prn='LPT'
C  Neu: REKO=' ', damit DOSWAHL auch im aktuellen Verzeichnis
C  die REKO.INI findet, wenn dies nicht c:\reko3 ist.
C  Dazu Anpassung in rekoini() erforderlich (text= ohne \).
C  Das geht doch nicht, siehe Transfer von PC-Crash in Reko.
      reko='c:\reko3'
c     reko=' '
      rec=' '
      strgf9=' '
      team='T:'
      top=4
      typ=' '
      verz=' '
c     xcopy='/-y'
      zurueck=.false.
      zurueck2=.false.
      zwdatei=' '
      dbverz='C:\EINGABE'
      tab='01'
C
      call cls
C
C  Kommandozeilen-Parameter lesen
C
      param=' '
      call getcl (param)
      if (param(1:1).eq.' ') param=param(2:)
      if (index(param,'/?').gt.0) then
        call info (zmax,dlaenge)
        stop
      end if
C  Parameter /1: Aufruf aus REKO oder EINGABE
      isp=.FALSE.
      if (index(param,'/1').gt.0) isp=.TRUE.
C  Parameter /8:xxx: Befehl beginn(xxx) statt stop am Ende ausfhren
c     isb=index(param,'/8:')
C
C  Normal   : Dateiliste DIR.TMP neu erstellen und dann erst lesen
C  Param. /2: Dateiliste DIR.TMP nicht erstellen, sondern nur lesen
      isn=.FALSE.
      if (index(param,'/2').gt.0) isn=.TRUE.
C
C  Sortierung
C
      sort='/ogn'
      i=index(param,'/o')
      if (i.gt.0) sort=param(i:)
      i=index(sort,'/')
      if (i.gt.5) sort(i:)=' '
C
C  Parameter
C  Die Option /s/b muss in OPT rein, andere Optionen drfen nicht,
C  z.B. /s/b/1 muss zu /s/b werden.
C
c     i=index(param,'/s/b')
c     if (i.gt.0) opt=param(i:i+3)
      i=index(param,'/s')
      if (i.gt.0) opt=param(i:i+1)
c
c     i=index(param,'/')
c     if (i.gt.0) then
c       opt=param(i:)
c       i=index(opt,'/0')
c       if (i.gt.0) opt(i:)=' '
c       i=index(opt,'/1')
c       if (i.gt.0) opt(i:)=' '
c       i=index(opt,'/3')
c       if (i.gt.0) opt(i:)=' '
c       i=index(opt,'/5')
c       if (i.gt.0) opt(i:)=' '
c     end if
C  Fallnummer lesen
C  Wenn alte Fallnummer dann JAHR=0, wichtig fr KDTPRUEF()
      fall=' '
      jahr=0
      call exist ('FALL.TMP',*370)
      open (11,file='FALL.TMP',err=370)
      read (11,'(A)',end=370) fall
      if (nblank(fall).eq.8) read (fall(3:4),'(I2)',err=370) jahr
370   close (11)
C
C  REKO.INI lesen
C
C  zeilen = Anzahl der Zeilen des Bildschirms (25, 43 oder 50)
C  anzahl = Anzahl der darstellbaren Dateien auf dem Bildschirm
      zeilen=25
      anzahl=zeilen-top-1
      graphik=.false.
101   call rekoini (reko,zeilen,anzahl,farbe,fmark,digi,prn,
     *isp,top,belege,graphik,team,dbverz)
C
C  Bei Programmstart automatisch die Laufwerke anzeigen (Strg-F10)
C  Bei Kapazittsproblemen deaktivierbar, wird nicht bentigt
C  Der Aufruf DOSWAHL /key:1103 (fr Strg-F10) hat die gleiche Funktion
C
c     i=index(param,'/0')
c     if (i.gt.0) then
c       param(i:)=' '
c       key=1103
c       call system ('cd\')
c       goto 350
c     end if
C
C  Bei Programmstart automatisch nach Suchtext suchen AKTIV!
C
      i=index(param,'/F:')
      if (i.gt.0) then
        merkfind=param(i+3:)
        i=index(merkfind,' ')
        if (i.gt.1) merkfind(i:)=' '
        parf=.true.
      end if
C
C  Erster Kommandozeilen-Parameter: zu lesende Dateien (VERZ)
C  VERZ geht nur bis zur ersten Option "/".
C
105   i=index(param,'\')
      if (i.gt.0) then
        verz=param(1:len(verz))
        i=index(verz,'/')
        if (i.gt.0) verz(i:)=' '
      end if

C  FILES erkennen
C   Entweder so
C   ja, weil nur so ein Verzeichnis als Verz. erkannt wird,
C   wenn kein \ folgt
      if (index(param,'*').gt.0.or.index(param,'?').gt.0) then
        i=letzt(param,'\')
        files=param(i+1:)
        verz(i:)=' '
        i=index(files,' ')
        if (i.gt.0.and.i.lt.nblank(files)) files(i:)=' '
        i=index(files,'/')
        if (i.gt.0) files(i:)=' '
      end if
C   Oder so
c     i=letzt(param,'\')
c     files=param(i+1:)
c     if (files.eq.' ') files='*.*'
c     verz(i:)=' '
c     i=index(files,' ')
c     if (i.gt.0.and.i.lt.nblank(files)) files(i:)=' '
c     i=index(files,'/')
c     if (i.gt.0) files(i:)=' '
C   Ende so
C  Ende FILES erkennen
C
C  Bei Programmstart die Taste "key" ausfhren
C  z.B. fr F8 (Digitale Akte):1066, also "DOSWAHL /key:1066"
C  Shift-F6 (Vergleich)(key=1089) muss anders behandelt werden
C
      i=index(param,'/key:')
      if (i.gt.0) then
        read (param(i+5:i+8),'(I4)',err=109) key
        if (key.ne.1089) goto 301
      end if
C
C  Laufwerk und Verzeichnis wechseln
C
109   if (.not.isn.and.verz.ne.' ') then
        call verzwechsel (verz)
      end if
C
C  Verzeichnisse und Dateien neu einlesen
C  Nicht fr Strg-R
C
111   if (key.ne.18) then
        marke=1
        altm=marke
        minmarke=marke
        maxmarke=anzahl
        altmin=minmarke
      end if
C  Das Verzeichnis wird per DIR-Befehl eingelesen;
C  VERZ bergeben und ermitteln
      imax=0
      call lesedaten (verz,files,sort,opt,datei,datum,zeit1,zeit2,
     *bytes,merkdate,marke,imax,zmax,hid,strgf9,isn,mkt,tab)
C  Abfrage der Verzeichnis-Datei
      call exist ('C:\DIR.TMP',*99)
C  Initialisierung der Markierung der Dateien
C  .not.isn wegen strg-*
      if (.not.isn) then
        anzmkt=0
        do i=1,zmax
          mkt(i)=' '
        end do
      end if
C  Nach der Verwendung von ISN muss es wieder zurckgesetzt werden
C  Nein, fr ESC nach Strg-* nicht sinnvoll.
c     isn=.FALSE.
C
C  Cursor in erste Bildschirmzeile
C  Wegen der Zwei Fenster darf es nicht CLS sein!
C
c     call cls
1     call position (1)

C  Ermittlung der Anzahl der markierten Dateien

      anzmkt=0
      do i=1,imax
        if (mkt(i).eq.'*') anzmkt=anzmkt+1
      end do
C
C  Obere Bildschirmleisten
C  BEFEHL hier nur fr die Anzeige von verz und files
C
c     befehl=tab
c     befehl(3:)='|'
c     befehl(4:)=verz
      befehl=verz
      i=nblank(befehl)
      if (befehl(i:i).ne.'\'.and.verz.ne.' ') befehl(i+1:)='\'
      befehl(nblank(befehl)+1:)=files
      if (hid) befehl(nblank(befehl)+2:)='/ah'
C  Aus Kapazittsgrnden deaktivierbar
      if (strgf9.ne.' ') then
        befehl='Datei-Filter:'
        befehl(15:)=strgf9
      end if
C  Ohne Farbe
      write (*,'(A,A)')
     *' [1A DOSWAHL:Enter Tab:Spalt Ausf:Strg-Ent Expl:Strg-E',
     *' Sh-Lw: Strg-C/V/X BSPC ESC ?'
      if (tab.eq.'01') then
        write (*,20) befehl(1:30),anzmkt,sort(2:)
20      format (2X,A30,T35,'M:',I4,'[2;74fS:',A4)
      else
        write (*,21) befehl(1:30),sort(2:)
21      format (' [2;42f',A30,'  S:',A4)
      end if
      write (*,'(2X,78(1H))')
C
C  Untere Bildschirmleiste
C
260   if (zeilen.eq.0) call position (25-2)
      if (zeilen.gt.0) call position (zeilen-2)
C  Ohne Farbe
      write (*,30)
30    format (2X,78(1H))
C  Normale F-Tasten
      if (isa.eq.0) then
        write (*,35)
35      format ('  F1:Hlf 2:Dir 3:Anz 4:Ber 5:Kop',
     *' 6:Umb 7:Dru 8:Akte 9:Sort 10:Krit 11:Lst 12:Alt[1A')
C  Alt-F?-Tasten
      else if (isa.eq.1) then
        write (*,36)
36      format ('  ALT-F2:DirV 3:Edit 5:DBVz',
     *' 6:Move 7:Find 8:Belegr 9:SDir 10:Verz 11:RChk 12:Ini[1A')
C  Shift-F?-Tasten
      else if (isa.eq.2) then
        write (*,37)
37      format ('  SH-F2:x.* 4:RecPCC 6:Tausch 7:Such',
     *' STRG-E:Explore B,K:Edit F:Such R:Read Q:End[1A')
C  Strg-F?-Tasten
      else
        write (*,38)
38      format ('  ST-F2:net 3:Ed 4:Graph 5:Att 6:Vgl 7:Such',
     *' 8:Tmp 9:Filt 10:Laufw 11:Lang L:Kurz[1A')
      end if
C
C  Anzeige bei falscher Dateiauswahl
C  Anders als bei AUSWAHL, hier strt diese Anzeige.
C
c       call position (top)
c       write (*,'(A//A,A52/A,A12//A/A/A/A)')
c    *  '  Keine Dateien oder Verzeichnisse gefunden!',
c    *  '  Verzeichnis    : ',verz,
c    *  '  Dateien        : ',files,
c    *  '  F10, Alt-F10   : Laufwerk, Verzeichnis, Dateien angeben',
c    *  '  Strg-F10, sh-x : Laufwerk x whlen oder sofort wechseln',
c    *  '  Alt-H          : Wechsel versteckte Dateien anzeigen'
c       goto 300
C
c  DOSWAHL: anders als ain AUSWAHL damit es weitergeht
      if (imax.eq.0) then
        write (*,'(A7,A)') '[2;4f',' Keine Dateien gefunden!'
        call pause
        verz=merkverz
c       files='*.*'
        files=merkkrit
        strgf9=' '
        isn=.false.
        goto 109
      end if
C
C  Anzeige der eingelesenen Dateinamen
C
100   call position (top-1)
C
C  Bestimmung der Bereichsgrenzen
C
C     call bereich (anzahl,imax,marke,minmarke,maxmarke)
C
C    Anpassung an genderte Bildschirmzeilen
      maxmarke=minmarke+(anzahl-1)
C    Markierung
      if (marke.lt.1) marke=1
      if (marke.gt.imax) marke=imax
C    Nach oben bewegen
      if (marke.lt.minmarke) then
        minmarke=marke
        maxmarke=minmarke+(anzahl-1)
      end if
C    Nach unten bewegen
      if (marke.gt.maxmarke) then
        maxmarke=marke
        minmarke=maxmarke-(anzahl-1)
      end if
C    Erste und letzte Datei
      if (minmarke.lt.1) minmarke=1
      if (maxmarke.gt.imax) maxmarke=imax
C    Erste Bildschirmseite
      if (maxmarke.lt.imax.and.imax.le.anzahl) maxmarke=imax
C
C  Anzeige der gelesenen Dateien und den Rest des Fensters lschen
c  (wegen cls in Zeile 1 ist das Lschen berflssig)
C  Fr DOSWAHL, ohne Zhler, einzelne Werte
C  BYTES=-1 ist ein Ordner (Verzeichnis)
C  Auf den Bildschirm passen zwei Spalten
C
      do i=minmarke,maxmarke
        if (tab.eq.'01') then
          write (*,50)
     *    mkt(i),datei(i),bytes(i),datum(i),zeit1(i),zeit2(i)
50        format (T2,A1,A12,1X,I9,1X,A,2X,I2,':',I2)
        else
C  Ein "T42" verusacht leider lschen des Textes davor.
c          write (*,51)
c     *    mkt(i),datei(i),bytes(i),datum(i),zeit1(i),zeit2(i)
c51        format (T42,A1,A12,1X,I9,1X,A,2X,I2,':',I2)
C  Diese Version lscht den Text davor nicht
          if (top+i-minmarke.le.9) then
            write (*,51) '[',top+i-minmarke,';41f',
     *      mkt(i),datei(i),bytes(i),datum(i),zeit1(i),zeit2(i)
51          format (A3,I1,A4,A1,A12,1X,I9,1X,A,2X,I2,':',I2)
          else
            write (*,52) '[',top+i-minmarke,';41f',
     *      mkt(i),datei(i),bytes(i),datum(i),zeit1(i),zeit2(i)
52          format (A3,I2,A4,A1,A12,1X,I9,1X,A,2X,I2,':',I2)
          end if
        end if
      end do

C  Rest lschen kann entfallen, wenn bei "1" das CLS steht.
      do i=1,anzahl-(maxmarke-minmarke)-1
        if (tab.eq.'01') then
          write (*,'(A40)') ' '
        else
c         write (*,'(A10)') '[;41f[K'
          j=i+maxmarke+top-1
          if (j.le.9) then
            write (*,'(A3,I1,A7)') '[',j,';41f[K'
          else
            write (*,'(A3,I2,A7)') '[',j,';41f[K'
          end if
        end if
      end do
C
C  Nach dem Suchtext suchen (Parameter /F:)
C  Fr Shift-F6 (1089) setze key nicht explizit auf 6
C
      if (parf) then
c     if (merkfind.ne.' ') then
        if (key.eq.0) key=6
        goto 351
      end if
C
C  Markierung setzen und entfernen
C  Nummer der Datei in der Titelzeile anzeigen (N:)
C
200   if (imax.gt.0) then
        alt=altm-altmin+top
        mrk=marke-minmarke+top
        write (*,'(A8,I4)') '[2;29f',marke

C  Markierung alter Zeile entfernen
C  Nur entfernen, wenn Bildschirmzeile gendert und alte Untergrenze
C  gleich neue Untergrenze
        if (mrk.ne.alt.and.altmin.eq.minmarke)
     *  then
          if (alt.lt.10) then
            write (*,210) '[',alt,';',tab,'f[',
     *      farbe(1:nblank(farbe)),'m',mkt(altm),
     *      datei(altm),bytes(altm),datum(altm),zeit1(altm),':',
     *      zeit2(altm)
          else
            write (*,220) '[',alt,';',tab,'f[',
     *      farbe(1:nblank(farbe)),'m',mkt(altm),
     *      datei(altm),bytes(altm),datum(altm),zeit1(altm),':',
     *      zeit2(altm)
          end if
        end if
C  Neue Zeile neu markieren
        if (mrk.lt.10) then
          write (*,230) '[',mrk,';',tab,'f[',
     *    fmark(1:nblank(fmark)),'m',mkt(marke),datei(marke),
     *    bytes(marke),datum(marke),zeit1(marke),':',zeit2(marke),
     *    '[',farbe(1:nblank(farbe)),'m'
        else
          write (*,240) '[',mrk,';',tab,'f[',
     *    fmark(1:nblank(fmark)),'m',mkt(marke),datei(marke),
     *    bytes(marke),datum(marke),zeit1(marke),':',zeit2(marke),
     *    '[',farbe(1:nblank(farbe)),'m'
        end if
      end if
210   format (A3,I1,A1,A2,A3,A,A1,A1,A,1X,I9,1X,A,2X,I2,A1,I2)
220   format (A3,I2,A1,A2,A3,A,A1,A1,A,1X,I9,1X,A,2X,I2,A1,I2)
230   format (A3,I1,A1,A2,A3,A,A1,A1,A,1X,I9,1X,A,2X,I2,A1,I2,A2,A,A1)
240   format (A3,I2,A1,A2,A3,A,A1,A1,A,1X,I9,1X,A,2X,I2,A1,I2,A2,A,A1)

C  Bisherige Markierung merken
      altm=marke
      altmin=minmarke
C
C  Angaben zur aktuellen Datei
C
C  Aktuelle Datei ohne Laufwerk und Pfad
C  Nicht fr Laufwerksbuchstaben

      aktfile=datei(marke)
      if (datei(marke)(2:3).eq.': ') aktfile=datei(marke)(1:2)

C  Mit Parameter /2: aktfile mit Laufwerk und Pfad
      if (index(param,'/2').gt.0
     *.and.index(aktfile,'\').eq.0
     *.and.verz.ne.' ') then
        aktfile=verz
        aktfile(nblank(aktfile)+1:)='\'//datei(marke)
        isn=.true.
      end if

C  fr FINDEN ohne Laufwerk,Pfad (testweise)
c     i=letzt(aktfile,'\')
c     if (i.gt.0) aktfile=aktfile(i+1:)

C  Gemerkte Datei (z.B. strt dies hier fr F9)
C     if (.NOT.ZURUECK.AND.imax.gt.0) merkdate=aktfile

C  Dateiart: isv=0 (Datei), isv=1 (Verzeichnis)

      isv=.FALSE.
C  Bisher in DOSWAHL
c     if (index(datei(marke),'<DIR>').gt.0) isv=.TRUE.
C  Neu in DOSWAHL
      if (bytes(marke).eq.-1) isv=.TRUE.
C   Ein Laufwerksbuchstabe wird wie ein Verzeichnis behandelt
C   Brauche ich nicht, da dieser auch bytes=-1 hat
c     if (aktfile(2:2).eq.':'.and.nblank(aktfile).eq.2) isv=.TRUE.

C  Ist die aktuelle Datei vorhanden?
C  Das nervt aber bei vielen anderen Sachen, also deaktiviert
c     if (.not.isv) call exist (aktfile,*1)
C
C  Typ der aktuellen Datei (aus Dateiname und Verzeichnis)
c     call dateityp (verz,aktfile,typ,rec)
C
C  Dateityp REKO-Datei
      i=index(aktfile,'REKO')
      if (i.gt.2) then
        typ=aktfile(i-2:i-1)
      end if
      i=index(aktfile,'DATEN')
      if (i.gt.2) then
        typ=aktfile(i-2:i-1)
      end if
      i=index(verz,'DATEN')
      if (i.gt.2.and.typ.eq.' ') then
        typ=verz(i-2:i-1)
      end if
      if (index('KA,FG,OB,VB,EP,SP',typ).eq.0) typ=' '
C  Dateityp REKO-Graphikdatei (nicht erforderlich)
c     i=index(aktfile,'GRAPH.DAT')
c     if (i.gt.0) then
c       typ=aktfile(i-2:i-1)
c     end if
C  Dateityp RECORD-Datei
      i=index(aktfile,'REC')
      if (i.gt.0) rec=aktfile(i+3:i+4)
      i=index(aktfile,'rec')
      if (i.gt.0) rec=aktfile(i+3:i+4)
      i=index(verz,'REC')
      if (i.gt.0.and.rec.eq.' ') rec=verz(i+3:i+4)
      if (index('01234',rec(1:1)).eq.0
     *.or.index('0123456789',rec(2:2)).eq.0) rec=' '
C
C  Tastaturabfrage
C
C  Fr Shift-F6 ber den Parameter /key:1089
      if (key.eq.1089) goto 301
300   key=ixkey()
301   continue
C
C  Bildbewegungsfunktionen
C
C  Cursor oben
      if (key.eq.1072) marke=marke-1
C  Cursor unten
      if (key.eq.1080) marke=marke+1
C  Bild oben
      if (key.eq.1073) marke=marke-(anzahl-1)
C  Bild unten
      if (key.eq.1081) marke=marke+(anzahl-1)
C  Pos1 (1071): erste Datei bzw. erstes Verzeichnis
C  und Lschen des Suchtextes fr STRG-F und Alt-F7
      if (key.eq.1071) then
        marke=1
        merkfind=' '
        parf=.false.
        goto 1
      end if
C  Ende
      if (key.eq.1079) marke=imax
C  Sonstiges
      if (key.eq.1132.or.key.eq.1117.or.key.eq.1118.or.key.eq.1119)
     *goto 300
C  Grenzen
      if (marke.lt.1) marke=1
      if (marke.gt.imax) marke=imax
C  Sprung zur Tastaturabfrage, wenn sich nichts ndert
C  marke=altm: keine nderung, Cursor ist bereits ganz oben/unten
      if (key.ge.1071.and.key.le.1081.or.key.eq.1118.or.key.eq.1132)
     *then
        if (marke.eq.altm) goto 300
C  Scrollen des Bildschirms (minmarke und maxmarke ndern sich)
C  marke<minmarke oder marke>maxmarke: Bildschirm wird neu aufgebaut
        if (marke.lt.minmarke.or.marke.gt.maxmarke) goto 100
C  Scrollen des Cursors bei gleichem Bildschirm (minmarke und maxmarke
C  ndern sich nicht)
C  Cursor setzen und bisherige und neue Zeile neu schreiben
        goto 200
      end if
C
C  Allgemeine Funktionen fr die Datei-/Verzeichnis-Liste
C
C  F1: Hilfe
c     if (key.eq.1059) call hilfe (reko)
      if (key.eq.1059) then
        befehl='list'
        befehl(6:)=reko
        befehl(nblank(befehl)+1:)='\DOSWAHL.DOK'
        call system (befehl)
        call cls
        isn=.true.
      end if

C  Shift-F1: Hilfe-Datei zur aktuellen Datei anzeigen
C  Fr ??REKO.DAT und fr REC??.KDT

      if (key.eq.1084) then
        befehl='list'
        befehl(6:)=reko
        befehl(nblank(befehl)+1:)='\'//aktfile
        if (index(aktfile,'REKO').gt.0) then
          befehl(index(befehl,'.'):)='1.HLF'
        else
          befehl(index(befehl,'.'):)='.HLF'
        end if
        inquire (file=befehl(6:),exist=ok)
        if (ok) call system (befehl)
        call cls
        isn=.true.
      end if

C  F2 (1060): DIR-Befehl fr Dateien

      if (key.eq.1060.and..not.isv) then
        call cls
c       write (*,'(1X,A,A/1X,A,A/)')
c    *'Ordner: ',verz,
c    *'Datei : ',aktfile
        print *,verz
        befehl='dir /p'
        befehl(8:)=aktfile
        call system (befehl)
        if (merkziel.ne.' ') then
c         write (*,'(1X,A,A/1X,A,A/)')
c    *  'Ordner: ',merkziel,
c    *  'Datei : ',aktfile
          print *,merkziel
          befehl='dir /p'
          befehl(8:)=merkziel
          befehl(nblank(befehl)+1:)='\'//aktfile
          call system (befehl)
        end if
        call pause
        isn=.true.
      end if

C  F2 (1060): DIR-Befehl fr Ordner

      if (key.eq.1060.and.isv) then
        befehl='dir'
        befehl(5:)=aktfile
        befehl(nblank(befehl)+1:)='>c:\temp\dir.tmp'
        call system (befehl)
        call system ('list c:\temp\dir.tmp')
        isn=.true.
      end if

C  Strg-F2 (1095): net use lw:

      if (key.eq.1095) then
        call cls
        befehl='net use'
        if (aktfile(2:2).eq.':') then
          befehl(9:)=aktfile
        else
          befehl(9:)=verz(1:2)
        end if
        call system (befehl)
        call pause
        isn=.true.
        call cls
      end if

C  Shift-F2 (1085): DIR <dateiname>.*

      if (key.eq.1085) then
        zurueck=.true.
        merkkrit=files
        merkdate=aktfile
        j=index(aktfile,'.')
        if (j.eq.0) then
          files=aktfile
          files(nblank(files)+1:)='.*'
        else
          files=aktfile(1:j)//'*.*'
        end if
        isn=.false.
      end if

C  Alt-F2  (1105): Wechsel in das zur Datei gehrende Verzeichnis
C  Ist nur fr Listen von Dateien aus unterschiedlichen Verzeichnissen,
C  wie sie z.B. bei FINDEN aus REKO oder EINGABE erstellt werden.
C  ZURUECK2 muss anders programmiert werden als ZURUECK.
C  FILES bleibt konstant (Fallnummer-bezogen), also nicht *.*!

      if (key.eq.1105) then
        merkdate=datei(marke)
        isn=.FALSE.
        i=letzt(aktfile,'\')
c       if (i.eq.0) goto 1
        if (i.gt.0) then
          call system ('copy c:\dir.tmp c:\dir1.tmp')
          zurueck2=.true.
          verz=aktfile(1:i-1)
          if (i.eq.nblank(aktfile)) then
c           files='*.*'
          else
            files=aktfile(i+1:i+6)
            files(7:)='*.*'
          end if
          goto 109
C  Alt-F2 fr die normale Anzeige: alle Dateien eines Falls
        else
          merkkrit=files
          zurueck=.TRUE.
          files='*'//fall
          if (fall(1:2).eq.'30') files(2:)=fall(3:8)
          files(nblank(files)+1:)='*.*'
        end if
      end if

C  F3: (1061): Datei anzeigen mit LIST

      if (key.eq.1061) then
        befehl='LIST'
        befehl(nblank(befehl)+2:)=aktfile
        if (fall.ne.' ') then
          befehl(nblank(befehl)+2:)='/Q/F'//fall
        end if
        call system (befehl(1:nblank(befehl)))
        call cls
        isn=.true.
      end if

C  Shift-F3 (1086): anzeigen mit TYPE (auch fr lange Dateinamen)
C  Bei Kapazittsproblemen deaktivierbar - wird kaum gebraucht.

      if (key.eq.1086) then
        call cls
        befehl='type'
        befehl(6:)=aktfile
        befehl(nblank(befehl)+1:)='|more'
        call system (befehl)
        call pause
        isn=.true.
        call cls
      end if

C  Shift-F3 (1086): anzeigen mit interner Funktion, ohne SYSTEM()
C  Nur mit 8.3-Dateinamen, dafr aber auch wenn F3 nicht mglich ist.

c      if (key.eq.1086) then
c        call cls
c        open (10,file=aktfile,err=1010)
c        i=1
c1000    if (i.eq.0) call pause
c        read (10,'(A80)',end=1010) text
c        write (*,'(1X,A)') text(1:nblank(text))
c        i=i+1
c        if (i.eq.zeilen-2) i=0
c        goto 1000
c1010    close (10)
c        call pause
c        call cls
c        isn=.true.
c      end if

C  Alt-F3   (1106): Datei editieren (REKOEDIT)
C  STRG-F3  (1096): Datei editieren (NOTEPAD)
C  Subroutine "editier()" aus Kapazittsgrnden im Hauptprogramm

      if ((key.eq.1106.or.key.eq.1096)
     *.and.index(param,'/4').eq.0) then
C    Hilfedatei bestimmen
C    Fr REC-Typen macht REKOEDIT dies
        text=' '
        if (rec.ne.' ') then
          text='REC'
          text(4:5)=rec
          text(6:)='.HLF'
        else if (typ.ne.' ') then
          text(1:2)=typ
          text(3:6)='REKO'
          text(7:)='1.HLF'
          if (index(aktfile,'ERG').gt.0) text(7:)='2.HLF'
        end if
C  Rekoverzeichnis vor Hilfedateinamen setzen
        if (text.ne.' ') then
          befehl=text
          text=reko
          text(nblank(text)+1:)='\'//befehl
        end if
C  Editor-Befehl
        if (key.eq.1106) then
          befehl='REKOEDIT'
          befehl(nblank(befehl)+2:)=aktfile
          befehl(nblank(befehl)+2:)=text
          befehl(nblank(befehl)+2:)='/E'
        else
c         befehl=editor
          befehl='notepad'
          befehl(nblank(befehl)+2:)=aktfile
        end if
        call system (befehl)
        call cls
        isn=.true.
C  automatisches F4 nach REKOEDIT: geht zwar, ist aber nicht schn
c       if (key.eq.1106) key=1062
      end if

C  F4 (1062):
C  REKO-Ergebnisse berechnen
C  Korrektur-Datei prfen / Datenbankdatei aktualisieren

      if (key.eq.1062) then
        isn=.true.
        do i=1,imax
        if (anzmkt.eq.0.and.aktfile.eq.datei(i)
     *  .or.anzmkt.gt.0.and.mkt(i).eq.'*') then
        if (typ.ne.' ') then
c         call berech (aktfile,zeilen,typ,key,graphik,*1)
          call berech (datei(i),zeilen,typ,key,graphik,*1)
          if (index(param,'/2').eq.0) then
            merkdate=aktfile
            isn=.false.
          end if
        else
c         call kdtpruef (aktfile,rec,typ,reko,jahr,*1)
          call kdtpruef (datei(i),rec,typ,reko,jahr,*1)
        end if
        end if
        end do
      end if

C  Strg-F4 (1097):
C  Graphik zu einer Reko-Eingabedatei anzeigen
C  Graphik zur Korrektur-Datei aufrufen

      if (key.eq.1097) then
        if (typ.ne.' ') then
          call berech (aktfile,zeilen,typ,key,graphik,*1)
        else
          befehl='RECGRAPH.EXE'
          if (verz.ne.' ') then
            befehl(14:)=verz
            befehl(nblank(befehl)+1:)='\'//aktfile
          else
            befehl(14:)=aktfile
          end if
C  Aufruf der Graphik hier statt in RECGRAPH.EXE wegen Arbeitsspeicher
          befehl(nblank(befehl)+2:)='/1/2'
          call cls
          call system (befehl)
          if (rec.ne.'20') goto 1
          if (graphik) then
            inquire (file='RECGRAPH.DAT',exist=ok)
            if (ok) then
              call pause
              befehl='GRAPHIK.EXE KA RECGRAPH.DAT'
              call system (befehl)
              call cls
              call setmode (zeilen)
            end if
          else
            write (*,*) ' Virtueller PC: GRAPH 1 aufrufen.'
          end if
          call pause
        end if
        isn=.true.
      end if

C  Shift-F4 (1087):
C  Transfer der Daten zu PC-Crash

      if (key.eq.1087) then
        call cls
        befehl='REKOPCC'
        befehl(9:)=aktfile
        call system (befehl)
C  zurck zum aktuellen Laufwerk
        call system (verz(1:2))
C  zurck zum aktuellen Verzeichnis
        befehl='cd'
        befehl(4:)=verz
        call system (befehl)
        isn=.false.
      end if
C
C  Alt-F5 (1108):
C  Eingabe-Verzeichnis aus #DBVERZ (REKO.INI)
C
      if (key.eq.1108) then
        merkverz=verz
        merkkrit=files
        zurueck=.true.
        verz=dbverz
        files='*.*'
        isn=.false.
        goto 109
      end if
C
C  Shift-F6 (1089): zwei Dateien vergleichen
C  Wenn keine andere Datei markiert ist (anzmkt=0),
C  wird die aktuelle Datei mit der REKO- oder der KDT-Datei verglichen
C  STRG-F6  (1099): zwei Dateien vertauschen
C
      if (key.eq.1089.or.key.eq.1099) then
        if (aktfile.eq.'..'.or.isv) goto 300
C  "Aktuelle Datei und REKO- oder KDT-Datei" - Anfang
C   Aus Kapazittsgrnden aber deaktivierbar
        if (anzmkt.eq.0) then
          if (merkziel.eq.' ') then
            merkziel=reko
            merkziel(nblank(merkziel)+1:)='\'
            if (typ.ne.' ') then
              merkziel(nblank(merkziel)+1:)=typ//'REKO.DAT'
            else if (rec.ne.' ') then
              merkziel(nblank(merkziel)+1:)='REC'//rec
              j=index(aktfile,'-')
              if (j.ge.6) then
                merkziel(nblank(merkziel)+1:)=aktfile(j:j+1)
              end if
              merkziel(nblank(merkziel)+1:)='.KDT'
            else
c  entweder
              goto 300
C  oder
C  Fr nicht markierte Keine-Reko-Dateien.
C  Funktioniert, aber aus Kapazittsgrnden deaktiviert
C  Wenn aktiviert, das "goto 300" in Spalte 1 mit einem "c" versehen!
c             call position (1)
c             write (*,*)' Zweite Datei:'
c             read (*,'(A)') merkziel
c             call exist (merkziel,*1)
c  ende entweder
            end if
C  Wenn merkziel bekannt - d.h. rechte Spalte angegeben
          else
            merkziel(nblank(merkziel)+1:)='\'//aktfile
          end if
        else
C  Aktuelle Datei und markierte andere Datei
          if (anzmkt.ne.1) goto 300
          i=1
          do while (mkt(i).eq.' '.and.i.le.imax)
            i=i+1
          end do
          if (i.eq.marke) goto 300
c         call vergletau (key,aktfile,datei(i))
C  Aktuelle Datei und zweite Datei als Vorgabe aus der aktuellen Datei
c         j=index(aktfile,'.')
c         if (j.gt.0) then
c           zwdatei=aktfile(1:j-1)
c           zwdatei(nblank(zwdatei)+1:)='.SIC'
c         end if
c         if (key.eq.1089) write (*,*) ' Vergleichen mit'
c         if (key.eq.1099) write (*,*) ' Vertauschen mit'
c         write (*,*) ' [2;18f [',zwdatei(1:nblank(zwdatei)),']:'
c         read (*,'(A)') text
c         if (text.ne.' ') zwdatei=text
C  Aktuelle Datei und zweite Datei nach Abfrage
c         call position (1)
cc    write (*,*)' Zweite Datei:                            [2;15f'
c         if (key.eq.1089)
c    *write (*,*)' Vergleichen mit:                         [2;18f'
c         if (key.eq.1099)
c    *write (*,*)' Vertauschen mit:                         [2;18f'
c         read (*,'(A)') zwdatei
c         if (zwdatei.eq.' ') goto 1
C  Ergnzung bei Abfrage (bei Kapazittsproblemen deaktivierbar)
c         j=index(zwdatei,'*.')
c         if (j.eq.1) then
c           text=zwdatei(j+1:)
c           zwdatei=aktfile
c           zwdatei(index(aktfile,'.'):)=text
c         end if
cc        print *,zwdatei
C  weiter
c         call exist (zwdatei,*1)
c         call vergletau (key,aktfile,zwdatei)
C  Quelltext von VERGLETAU() hierhin verschoben
C  Verwendung von MERKZIEL bedarf weniger Kapazitt
          merkziel=datei(i)
C  "Aktuelle Datei und REKO- oder KDT-Datei"-Ende
        end if

C  Fr Shift-F6 (vergleichen)
C  Verwende aktuelles Verzeichnis statt C:\TEMP fr krzeren Befehl
C  (erforderlich fr lngere Dateinamen)

        if (key.eq.1089) then
          befehl='FC'
          befehl(4:)=aktfile
          befehl(nblank(befehl)+2:)=merkziel
          befehl(nblank(befehl)+2:)='/N>VGL.TMP'
          call system (befehl)
          call system ('LIST VGL.TMP')
C  Das System fragt nach berschreiben, daher deaktiviert
c         call system ('move VGL.TMP c:\temp')
          call cls
          isn=.true.
        end if

C  Fr Strg-F6 (vertauschen)

        if (key.eq.1099) then
C  nur erforderlich fr rentmp(), nicht fr kopier()
cc         inquire (file='T.TMP',exist=ok)
cc         if (ok) goto 1
c          call existbereits ('T.TMP',*1)
           call cls
          write (*,*)' Vertauschen ',aktfile(1:nblank(aktfile)),
     *' mit ',merkziel(1:nblank(merkziel)),' (J/N)?'
          call askjn (*199)
C  rentmp funktioniert nicht beim Versuch, eine gespeicherte Datei
C  mit einer aktuellen REKO-Datei zu vertauschen
c         call rentmp (aktfile,'T.TMP')
c         call rentmp (merkziel,aktfile)
c         call rentmp ('T.TMP',merkziel)

          call kopier (aktfile,'T.TMP')
          call kopier (merkziel,aktfile)
          call kopier ('T.TMP',merkziel)
          call system ('move T.TMP c:\temp')

          call pause
          merkdate=aktfile
          isn=.false.
199     end if
C  Fr Shift-F6 ber den Parameter /key:1089
        key=0
      end if
C
C  Strg-F5   (1098): Attribute anzeigen und setzen
C  F5        (1063): Aktuelle Datei kopieren
C  F6        (1064): Aktuelle Datei umbenennen
C  F7        (1065): Aktuelle Datei drucken
C  Alt-F6    (1109): Aktuelle Datei verschieben (bewegen)
C  Strg-Entf (1147): Aktuelle Datei lschen (endgltig)
C  ENTF      (1083): Aktuelle Datei lschen (nach C:\TEMP verschieben)
C
      if ((key.eq.1063.or.key.eq.1064.or.key.eq.1109.or.key.eq.1147
     *.or.key.eq.1083.or.key.eq.1098.or.key.eq.1065)
     *.and.index(param,'/4').eq.0.and.aktfile.ne.'..') then
        merkdate=datei(marke)
        call aktionen (marke,merkziel,datei,mkt,anzmkt,imax,
     *  key,isv,aktfile,prn,verz,fall,bytes,*1)
        isn=.true.
        if (index(param,'/2').eq.0) isn=.FALSE.
C  Umbenennen: gemerkte Datei ist umbenannte Datei
c       if (key.eq.1064) then
c         merkdate=neuziel
C  Lschen: gemerkte Datei ist nchste Datei
c       else if (key.eq.1083.or.key.eq.1147) then
c       if (key.eq.1083.or.key.eq.1147) then
c         merkdate=datei(marke+1)
C  Sonst: gemerkte Datei ist aktuelle Datei
c       else
c         merkdate=datei(marke)
c       end if
      end if

C  Strg-F7: Textsuche (intern)
C  Hier in DOSWAHL nur interne Textsuche
C  Wegen Kapazitt ins Hauptprogramm verschoben
C  Wegen Kapazitt auch ohne upper() mglich, dann wird Klein-/Gro-
C  Schreibung bercksichtigt
C
c      if (key.eq.1100) then
c        befehl=' '
c        call position(1)
c        write (*,*) ' Alle/markierte Dateien, suche Text: [2;38f'
c        read (*,'(A)',end=1) befehl
c        if (befehl.eq.' ') goto 1
c        write (*,*) ' Gro/klein beachten (J/N)?'
c        grkl=.false.
c        call askjn (*125)
c        grkl=.true.
c125     if (.not.grkl) befehl=upper(befehl)
c        open (16,file='C:\temp\SUCHEN.TXT')
c        rewind (16)
c        do i=1,imax
c          j=0
c          if (index(datei(i),'..').eq.0.and.bytes(i).ge.0
c     *    .and.(anzmkt.eq.0.or.mkt(i).eq.'*')) then
c            open (15,file=datei(i),err=140)
c            write (16,'(A)') datei(i)
c            write (*,'(1X,A)') datei(i)
c130         read (15,'(A)',end=140) text
c            j=j+1
c            temp=text
c            if (.not.grkl) temp=upper(text)
c            if (index(temp,befehl(1:nblank(befehl))).gt.0) then
c              write (16,'(I5,A1,A)') j,':',text
c            end if
c            goto 130
c140         close (15)
c          end if
c        end do
c        close (16)
c        call system ('list C:\temp\SUCHEN.TXT')
c        call cls
c        isn=.true.
c        goto 1
c      end if

C  Strg-F7: Textsuche (extern)
C  Aus Kapazittsgrnden deaktivierbar, aber nur bei Aktivierung
C  der internen Textsuche (Shift-F7).

      if (key.eq.1100) then
        befehl='SUCHEN.EXE'
        befehl(12:)=files
        befehl(nblank(befehl)+2:)='/1'
        call system (befehl)
        call cls
        isn=.true.
      end if

C  Shift-F7: Anzeige des Suchergebnisses
C  Aus Kapazittsgrnden deaktivierbar

      if (key.eq.1090) then
        call system ('list C:\temp\SUCHEN.TXT')
        call cls
        isn=.true.
      end if

C  Alt-F7: Suche nach einer Datei (nicht in Unterverzeichnissen)

      if (key.eq.1110) then
        call position(1)
        write (*,*) ' Datei-Suche:                          [2;15f'
        read (*,'(A)',end=1) merkfind
        if (merkfind.eq.' ') goto 1
        merkverz=verz
        merkkrit=files
        zurueck=.TRUE.
c       opt='/s'
        files=merkfind
        files(nblank(files)+1:)='*.*'
        isn=.false.
      end if

C  F8      : Digitale Akte (1066)
C  Alt-F8  : Belege-Ordner (1111)
C  Strg-F8 : Wiederherstellen aus C:\TEMP (1101)
C  Shift-F8: Dateien *.SIC anzeigen (1091)
C            bei Kapzittsproblemen deaktivierbar, da nicht erforderlich
C  STRG-T  : Fall im Team-Ordner (20)

      if (key.eq.1066.or.key.eq.1111.or.key.eq.1101.or.key.eq.1091
     *.or.key.eq.20) then
C  Kein "zurueck" wenn /key: angegeben wurde,
C  da beim ersten Aufruf kein vorheriges Verzeichnis definiert ist
c       if (index(param,'/key:').gt.0) then
C  Kurzform wegen Kapazitt
        if (merkverz.eq.verz) then
          zurueck=.false.
        else
          merkverz=verz
          merkkrit=files
          zurueck=.TRUE.
        end if
C  Hier files doch angeben da ggf als Kommandozeilenparameter vorhanden,
C  der aber dann nicht verwendet werden darf.
C  Ohne FILES da in REKO bei Transfer von PC-Crash angegeben (*.txt)
c       if (key.ne.1111) files='*.*'
        if (key.eq.1101) then
          files='*.*'
          verz='C:\TEMP'
        end if
        if (key.eq.1091) files='*.SIC'
C  Digitale Akte
C  Team-Ordner: entweder "T:" und "true" (oder "T:\" und "false").
C  Verwende T: in Analogie zu REKO.FOR.
        if (key.eq.1066.or.key.eq.20) then
          verz=digi
          if (key.eq.20) verz=team
          call pfad (verz,fall,.true.,jahr)
        end if
C  Belege-Ordner
        if (key.eq.1111) then
          verz=belege
          call pfad (verz,fall,.false.,jahr)
        end if
C  merkfind ist nicht unbedingt erforderlich
c       merkfind=' '
c       merkfind=fall(1:6)
c  parf=.false, sonst Endlosschleife bei "/F:xxx /key:1066"
C  [Ersetze parf=.false. durch merkfind=' ']
        parf=.false.
        isn=.FALSE.
        goto 109
      end if
C
C  Strg-*: nur markierte Dateien anzeigen
C  Der Stern *. dient dazu, nicht den Inhalt eines markierten Ordners,
C  sondern die Daten des Ordners anzuzeigen.
C  Nicht bei Dateien anwenden.
C
      if (key.eq.29.and.anzmkt.gt.0) then
        open (12,file='C:\DIR.TMP',status='scratch')
        close (12)
        do i=1,imax
        if (mkt(i).eq.'*') then
          befehl='dir'
          befehl(5:)=datei(i)
          if (bytes(i).eq.-1) befehl(nblank(befehl)+1:)='*.'
          befehl(nblank(befehl)+1:)='>>c:\dir.tmp'
          call system (befehl)
        end if
        end do
        isn=.true.
        goto 111
      end if
C
C  F9: Sortieren
C
      if (key.eq.1067) then
        merkdate=datei(marke)
c  Anfang - Sortieren
C  Initialisierungen
      iso=.TRUE.
      if (index(sort,'-').gt.0) iso=.FALSE.
      altsort=sort
C  Textausgabe
400   call cls
      write (*,40) verz,sort
40    format ('  SORTIEREN'/,
     *'  Auswahl   : ',A12/,
     *'  Sortierung: ',A5//,
     *'  ( ) Ohne Sortierung'/,
     *'  (n) Sortierung nach Dateiname  '/,
     *'  (e) Sortierung nach Erweiterung'/,
     *'  (s) Sortierung nach Dateigre '/,
     *'  (d) Sortierung nach Datum/Zeit '//,
     *'  TAB: Wechsel Sortierung Vor/Rck'/,
     *'  Ihre Wahl (mit Enter besttigen):')
C  Tastaturabfrage
C  ( )=32, n=110, e=101, s=115, d=100, tab=9, enter=13, esc=27
      key=0
      do while (index(' nesd',char(key)).eq.0
     * .and.key.ne.9.and.key.ne.13)
        key=ixkey()
      end do
C  Sortierungsrichtung ndern
      if (key.eq.9) then
        if (iso) then
          iso=.FALSE.
        else
          iso=.TRUE.
        end if
      end if
C  Sortierung anpassen
      if (iso) then
        if (key.eq.110.or.index(sort,'-n').gt.0.or.sort.eq.' ')
     *   sort='/ogn'
        if (key.eq.101.or.index(sort,'-e').gt.0) sort='/oge'
        if (key.eq.115.or.index(sort,'-s').gt.0) sort='/ogs'
        if (key.eq.100.or.index(sort,'-d').gt.0) sort='/ogd'
      else
        if (key.eq.110.or.index(sort,'n').gt.0.or.sort.eq.'  ')
     *   sort='/og-n'
        if (key.eq.101.or.index(sort,'e').gt.0) sort='/og-e'
        if (key.eq.115.or.index(sort,'s').gt.0) sort='/og-s'
        if (key.eq.100.or.index(sort,'d').gt.0) sort='/og-d'
      end if
C  Sortierung zurcksetzen
      if (key.eq.32) sort=' '
C  Anzeige aktualisieren
      if (key.ne.27.and.key.ne.13) goto 400
C  Zurck zum Hauptprogramm
      if (key.eq.27) then
        sort=altsort
c       return 1
        key=0
        goto 1
      end if
      if (key.eq.13) then
c       if (sort.eq.altsort) return 1
c       return
        if (sort.eq.altsort) goto 1
        key=0
      end if
c  Ende - Sortieren
        isn=.FALSE.
      end if
C
C  Alt-F9: Angezeigte Dateiliste sichern Version 1
C  Kann bei Kapazittsproblemen deaktiviert werden
c     if (key.eq.1112) then
c       call position (1)
c       write (*,*) ' Dateiliste sichern als:               [2;25f'
c       read (*,'(A)') merkziel
c       if (merkziel.eq.' ') goto 1
c       befehl='copy C:\DIR.TMP'
c       befehl(22:)=merkziel
c       call system (befehl)
c       call pause
c       isn=.true.
c     end if

C  Alt-F9: Angezeigte Dateiliste sichern Version 2
C  Kann bei Kapazittsproblemen deaktiviert werden

c     if (key.eq.1112) then
c       call position (1)
c       write (*,*) ' Dateiliste wird als C:\DIR.TXT gesichert.'
c       befehl='copy C:\DIR.TMP C:\DIR.TXT'
c       call system (befehl)
c       call pause
c       isn=.true.
c     end if

C  Shift-F9: Gesicherte Dateiliste wiederverwenden Version 1
C  Kann bei Kapazittsproblemen deaktiviert werden, wird nie bentigt

c      if (key.eq.1092) then
cc       call cls
cc       write (*,*) ' Gesicherte Dateiliste zum Wiederverwenden: '
c        call position (1)
c        write (*,*) ' Gesicherte Dateiliste verwenden:     [2;34f'
c        read (*,'(A)') merkziel
c        if (merkziel.eq.' ') goto 1
c        call exist (merkziel,*1)
c        befehl='copy'
c        befehl(6:)=merkziel
c        befehl(nblank(befehl)+2:)='C:\DIR.TMP'
c        call system (befehl)
c        call pause
c        isn=.true.
c      end if

C  Shift-F9: Gesicherte Dateiliste wiederverwenden Version 2
C  Funktioniert nicht, daher bleibt es deaktiviert
C  Kann bei Kapazittsproblemen deaktiviert werden

c     if (key.eq.1092) then
c       befehl='copy C:\DIR.TXT C:\DIR.TMP'
c       call system (befehl)
c       call pause
c       isn=.true.
c     end if

C  Strg-F9: Filter, nur Dateien mit Suchtext anzeigen
      if (key.eq.1102) then
        isn=.false.
        call position (1)
        write (*,*) ' Datei-Filter:                         [2;16f'
        read (*,'(A)',end=1) strgf9
C  Mit STRG-F9 + Enter den Filter zurcksetzen (Sprung zu 111)
        if (strgf9.eq.' ') goto 111
        strgf9=upper(strgf9)
C  Mit ESC kann der Filter zurckgesetzt werden (Sprung zu 109)
        zurueck=.true.
      end if

C  F10: Datei-Kriterien, Auswahl
C  '*': alle Dateien anzeigen
C  Shift-F10: files*.* statt files.*
C  merkfind=' ' und parf=.false.
c  damit Strg-F nach F10 auf Anhieb funktioniert

      if (key.eq.1068.or.key.eq.42.or.key.eq.1093) then
        merkkrit=files
        zurueck=.TRUE.
        opt=' '
        if (key.eq.42) then
          files='*.*'
        else if (key.eq.1093) then
          i=index(files,'.')
          files(i:)='*.*'
        else
          call waehlen (verz,files,.FALSE.,*1)
        end if
        parf=.false.
        merkfind=' '
        isn=.FALSE.
      end if

C  Alt-F10: Angabe von Laufwerk, Verzeichnis und Dateikriterien

      if (key.eq.1113) then
        merkverz=verz
        merkkrit=files
        zurueck=.TRUE.
        call waehlen (verz,files,.TRUE.,*1)
        isn=.FALSE.
        goto 109
      end if

C  F11 (1133): Liste der Dateien anzeigen

      if (key.eq.1133) then
        call system ('LIST C:\DIR.TMP')
        call cls
        isn=.true.
      end if

C  Shift-F11 (1135): Prfen mit RECCHEK, was zu aktualisieren ist
C  bergabe der Fallnummer und des DBVERZ-Verzeichnisses erforderlich,
C  da DOSWAHL nicht nur aus dem REKO3-Verzeichnis heraus aufgerufen
C  wird und RECCHEK dann die FALL.TMP und die REKO.INI nicht findet.

      if (key.eq.1135) then
        befehl='RECCHEK'
        befehl(9:)=fall
        befehl(18:)='/X'
        befehl(20:)=rec
        befehl(22:)='/R/D:'
        befehl(27:)=dbverz
        call system (befehl)
        call pause
        isn=.true.
      end if

C  Alt-F11 (1139): Prfen mit RECCHEK, was schon vorhanden ist
C  /N und anschlieend RECCHEK.TXT anzeigen erforderlich wegen RAM

      if (key.eq.1139) then
        befehl='RECCHEK'
        befehl(9:)=fall
        befehl(18:)='/N/T/D:'
        befehl(25:)=dbverz
        call system (befehl)
        call pause
        befehl='list'
        befehl(6:)=reko
        befehl(nblank(befehl)+1:)='\recchek.txt'
        call system (befehl)
        call cls
        isn=.true.
      end if

C  STRG-F11 (1137): Dateiliste mit langen Dateinamen auch bei CMD=0.
C  Hier absichtlich ohne /-n, damit lange Dateinamen erscheinen
C  Bei Kapazittsgrnden deaktivierbar

      if (key.eq.1137) then
        befehl='cmd/c DIR'
        befehl(nblank(befehl)+2:)=files
        befehl(nblank(befehl)+2:)=sort
        befehl(nblank(befehl)+2:)='>C:\DIR.TMP'
        call system (befehl)
        call system ('LIST C:\DIR.TMP')
        call cls
        isn=.true.
      end if

C  F12: Funktionstasten F?, Alt-F?, Shift-F?, Strg-F?

      if (key.eq.1134) then
        isn=.true.
        if (isa.eq.0) then
          isa=1
        else if (isa.eq.1) then
          isa=2
        else if (isa.eq.2) then
          isa=3
        else
          isa=0
        end if
        goto 260
      end if

C  Alt-F12: REKO.INI bearbeiten (editieren)

      if (key.eq.1140) then
        isn=.true.
        befehl='REKOEDIT'
        befehl(10:)=reko
        befehl(nblank(befehl)+1:)='\REKO.INI /1'
        call system (befehl)
        goto 101
      end if
C
C  Sondertasten
C
C  Strg-L: Kurze Zusammenfassung
C  Im Norton Comander ist dies auch STRG-L.
C
      if (key.eq.12) then
        call cls
        open (13,file='C:\DIR.TMP',err=99)
500     read (13,'(A)',end=510) befehl
        if (befehl(1:1).eq.' ') write (*,*) befehl(1:nblank(befehl))
        goto 500
510     close (13)
        write (*,*)
        call pause
        goto 1
      end if
C
C  Alt-Z: ZWEIWAHL.EXE
C
      if (key.eq.1044) then
        befehl='ZWEIWAHL.EXE'
        befehl(14:)=param
        call system (befehl)
        isn=.true.
      end if
C
C  Strg-Plus und Strg-Minus (Bildschirmgre)
C  Erlaubt: 25, 43, 50
C
      if (key.eq.1144) then
        if (zeilen.eq.43) zeilen=50
        if (zeilen.eq.25) zeilen=43
      end if
      if (key.eq.1142) then
        if (zeilen.eq.43) zeilen=25
        if (zeilen.eq.50) zeilen=43
      end if
      if (key.eq.1144.or.key.eq.1142) then
        anzahl=zeilen-top-1
        call cls
        isn=.false.
        goto 1
      end if
C
C  "?": Info
      if (key.eq.63) call info (zmax,dlaenge)
C
C  Alt-M: Anzeige des freien Speichers
C  Bei Kapazittsproblemen deaktivierbar
C
      if (key.eq.1050) then
        call cls
        call system ('mem')
        call pause
        isn=.true.
        call cls
      end if
C
C  STRG-B (2) : Datei mit  EDIT bearbeiten
C  STRG-K (11): Datei mit KEDIT bearbeiten
C  EDIT.EXE oder EDIT.COM muss im PATH liegen;
C  EDIT kann auch lange Dateinamen verwenden. KEDIT nicht.
C  Eines von beiden oder beide wegen Kapazitt deaktivierbar.
C
      if (key.eq.2) then
        befehl='EDIT'
        befehl(nblank(befehl)+2:)=aktfile
        call system (befehl)
        isn=.true.
      end if
      if (key.eq.11) then
        befehl='KEDIT'
        befehl(nblank(befehl)+2:)=aktfile
        call system (befehl)
        isn=.true.
      end if

C  Alt-B (1048): Baumstruktur (tree) erstellen oder anzeigen
C  Ohne CMD, da sonst immer ein anderer Ordner gescannt wird
C  als der aktuelle

      if (key.eq.1048) then
        write (*,*) '[2;f Lese Baumstruktur ...'
        call system ('tree>c:\temp\tree.tmp')
        call system ('list c:\temp\tree.tmp')
        call cls
        isn=.true.
      end if

C  Strg-R: Noch einmal einlesen
C  MERKDATE ist hier nicht unbedingt erforderlich

      if (key.eq.18) then
        merkdate=datei(marke)
        isn=.FALSE.
        if (nblank(verz).eq.2) then
          key=1103
          goto 350
        end if
      end if

C  Alt-H: Versteckte Dateien und Verzeichnisse anzeigen

      if (key.eq.1035) then
        if (hid) then
          hid=.FALSE.
        else
          hid=.TRUE.
        end if
        isn=.FALSE.
      end if

C  Alt-D (1032): Neue Datei erstellen
C  Alt-V (1047): Neues Verzeichnis erstellen

      if (key.eq.1032.or.key.eq.1047) then
        isvneu=.FALSE.
        if (key.eq.1047) isvneu=.TRUE.
        call erstell (isvneu,merkdate,*1)
        isn=.FALSE.
      end if

C  Alt-X: DOS

      if (key.eq.1045) then
        call cls
c       write (*,'(A//)') ' [0m DOSWAHL.EXE: Zurck mit EXIT!'
        call system ('command')
        write (*,'(A3,A,A1)') '[',farbe(1:nblank(farbe)),'m'
        isn=.true.
      end if

C  Alt-L: Laufwerksbezeichnung anzeigen und ndern (LABEL)
C  Aus Kapazittsgrnden nur in der Laufwerksbersicht

      if (key.eq.1038) then
        call cls
        befehl='LABEL'
c       if (aktfile(2:2).eq.':'.and.nblank(aktfile).eq.2) then
          write (*,'(A,A//)') ' Aktuelles Laufwerk: ',aktfile(1:2)
          befehl(7:)=aktfile(1:2)
c       else
c         write (*,'(A,A//)') ' Aktuelles Laufwerk: ',verz(1:2)
c         befehl(7:)=verz(1:2)
c       end if
        call system (befehl)
        call pause
        if (nblank(verz).eq.2) then
          key=1103
          goto 350
        end if
        isn=.true.
      end if
C
C  STRG-C ( 3): Datei kopieren
C  STRG-V (22): Datei einfgen
C  STRG-X (24): Datei verschieben
C
C  Neues Vorgehen:
C  Strg-C schreibt den Pfad und entweder den Namen der aktuellen Datei
C  oder die Namen der mit * markierten Dateien in die Datei AUSWAHL.DAT
C  im Ordner C:\TEMP.
C  Strg-V liest C:\TEMP\AUSWAHL.DAT und kopiert (Strg-X verschiebt)
C  diese Dateien in den aktuellen Ordner.

C  STRG-C (3)
C  Pfad und Dateinamen in AUSWAHL.DAT in C:\TEMP schreiben
C
      if (key.eq.3) then
        open (12,file='C:\TEMP\AUSWAHL.DAT',err=297)
        write (12,*) verz
        if (anzmkt.eq.0) then
          write (12,*) aktfile
        else
          do i=1,imax
            if (mkt(i).eq.'*') write (12,*) datei(i)
          end do
        end if
297     close (12)
        write (*,*) '[2;f C:\TEMP\AUSWAHL.DAT geschrieben.'
        call pause
        isn=.true.
      end if

C  STRG-V (22) kopieren
C  STRG-X (24) verschieben
C  NT4: move funktioniert nicht
C  Bei XCOPY statt COPY braucht man die EXIST Abfrage nicht,
C  ist aber zum Kopieren langsamer.
C  XCOPY ermglicht "Alle" als Antwort zum berschreiben, COPY nicht.

      if (key.eq.22.or.key.eq.24) then
        call cls
c       call system ('list C:\TEMP\AUSWAHL.DAT')
        open (12,file='C:\TEMP\AUSWAHL.DAT',err=299)
        read (12,'(A)',end=299) zwpfad
        if (key.eq.22) text='kopieren'
        if (key.eq.24) text='verschieben'
        write (*,*)
     *  '[2;f Dateien aus ',zwpfad(1:nblank(zwpfad)),' ',
     *  text(1:nblank(text)),' (J/N)?'
        call askjn(*299)
290     read (12,'(A)',end=298) zwdatei
        if (key.eq.22) befehl='XCOPY'
        if (key.eq.24) befehl='MOVE'
        if (index(zwdatei,'\').eq.0) then
          befehl(7:)=zwpfad
          befehl(nblank(befehl)+1:)='\'//zwdatei
c         inquire (file=zwdatei,exist=ok)
        else
          befehl(7:)=zwdatei
c         inquire (file=zwdatei(letzt(zwdatei,'\')+1:),exist=ok)
        end if
c       if (ok) then
c         write (*,*)
c    *  '[2;f berschreiben (J/N)? ',zwdatei(1:nblank(zwdatei))
c         call askjn(*290)
c       end if
        call system (befehl)
        goto 290
298     call pause
        isn=.false.
        merkdate=zwdatei
299     close (12)
      end if
C
C  EINFG, INSERT oder Leertaste: Datei markieren
C  Auch aktfile="..", um dieses mit F7 drucken zu knnen

      if (key.eq.1082.or.key.eq.32) then
        if (aktfile.eq.' ') goto 300
        if (mkt(marke).eq.' ') then
          mkt(marke)='*'
          anzmkt=anzmkt+1
        else
          mkt(marke)=' '
          anzmkt=anzmkt-1
        end if
        if (key.eq.1082) then
          if (marke.lt.imax) marke=marke+1
          if (marke.lt.minmarke.or.marke.gt.maxmarke) goto 100
        end if
C  Anzeige der Anzahl der markierten Dateien (M:)
        write (*,'(A8,I4)') '[2;36f',anzmkt
        isn=.false.
        goto 200
      end if

C  Num-Plus-Taste  (43): Markieren mit Kriterium
C  Num-Minus-Taste (45): Demarkieren mit Kriterium

      if (key.eq.43.or.key.eq.45) then
        call markieren (datei,mkt,imax,key,merkmark,bytes)
c       farbe,fmark
        isn=.true.
      end if
C
C  Schnellsprung
C
C  Raute #: Schnellsprung zu Datei-Nummer
C  Aus Kapazittsgrnden deaktivierbar, wird nicht bentigt
C
c      if (key.eq.35) then
c        call position (1)
c        i=marke
c        write (*,*) ' (Zurck mit Enter) Nummer der Datei: '
c        read (*,'(I4)',err=115) i
c115     if (i.lt.1.or.i.gt.imax) goto 1
c        marke=i
c       isn=.false.
c      end if
C
C  TAB: Wechsel Dateianzeige links und rechts
C  In ZWEIWAHL wird hier merkverz nicht verwendet, warum hier?
C  merkdate setzt den Cursor auf die gleiche Datei, sofern vorhanden
C
      if (key.eq.9) then
        if (tab.eq.'01') then
          tab='41'
          merkverz=verz
          merkkrit=files
          verz=merkziel
          merkdate=aktfile
        else
          tab='01'
          merkziel=verz
          verz=merkverz
          files=merkkrit
C (nur fr links nach rechts, nicht umgekehrt)
          merkdate=aktfile
        end if
        isn=.false.
        goto 109
      end if
C
C  TAB          (9): Sprung auf nchste x*10 Datei weiter
C  Shift-TAB (1015): Sprung auf nchste x*10 Datei zurck
C  bei Kapazittsproblemen deaktivierbar
C
cc    if (key.eq.1015) marke=((int((marke+9)/10)-1)*10)
cc    if (key.eq.9)    marke=((int(marke/10)+1)*10)
c     if (key.eq.1015) marke=marke-10
c     if (key.eq.9)    marke=marke+10
C
C  Strg-Tab: Markierung vertauschen
C  Bei Kapazittsproblemen deaktivierbar - wird kaum gebraucht
C
      if (key.eq.1148) then
        do i=1,imax
          if (mkt(i).eq.' ') then
            mkt(i)='*'
          else
            mkt(i)=' '
          end if
        end do
        isn=.false.
      end if
C
C  STRG-Cursor oben  (1141): Sprung auf nchste x*5 Datei zurck
C  STRG-Cursor unten (1145): Sprung auf nchste x*5 Datei weiter
C
c     if (key.eq.1141) marke=int(marke/5-1)*5
c     if (key.eq.1145) marke=int(marke/5+1)*5
      if (key.eq.1141) marke=marke-5
      if (key.eq.1145) marke=marke+5
C
C  ?: Schnellsprung zu Datei mit Anfangsbuchstaben a-z (ohne Shift!)
C     bzw. Anfangsziffer 0-9 und auch _ (95), ebenso
C     (132),(142), (148),(153), (129),(154).
C
      if (key.ge.97.and.key.le.122.or.key.ge.48.and.key.le.57
     *.or.key.eq.132.or.key.eq.142.or.key.eq.148
     *.or.key.eq.153.or.key.eq.129.or.key.eq.154
     *.or.key.eq.95) then
        i=marke+1
        if (i.gt.imax) i=1
        weiter=.true.
        do while (i.le.imax)
c  entweder
c         ch=datei(i)(1:1)
c         if (ch.eq.'"') ch=datei(i)(2:2)
c         if (ch.eq.char(key).or.ch.eq.char(key-32)) then
c  oder
          ch1=datei(i)(1:1)
          ch2=' '
          j=index(datei(i),' ')
          if (datei(i)(1:2).eq.fall(1:2)) then
            ch2=datei(i)(11:11)
C  Aus Kapazittsgrnden nur mit dem einfachen ELSE auch mglich
          else
c         else if (j.lt.nblank(datei(i))) then
            ch2=datei(i)(j+1:j+1)
          end if
          if (ch1.eq.char(key).or.ch1.eq.char(key-32)
     *    .or.ch2.eq.char(key).or.ch2.eq.char(key-32)) then
c  ende entweder
            marke=i
            goto 120
          end if
          i=i+1
          if (i.gt.imax.and.weiter) then
            i=1
            weiter=.false.
          end if
        end do
        isn=.false.
120   end if
C
C  STRG-D (4): Desktop des Benutzers
C  oder mit BACKSPACE aus der Laufwerksbersicht
C  Bei Kapazittsproblemen deaktivierbar
C
      if (key.eq.4
     *.or.key.eq.8.and.nblank(verz).eq.2.and.verz(2:2).eq.':') then
        merkverz=verz
        merkkrit=files
        zurueck=.false.
        if (key.eq.4) zurueck=.true.
C  Fr Windows 7
        inquire (file='c:\users\nul',exist=ok)
        if (ok) then
          verz='C:\Users'
C  Fr Windows XP oder den virtuellen XP-Modus
        else
          verz='C:\DOKUME~1'
        end if
        verz='c:\Users'
        files='*.*'
        isn=.false.
        goto 109
      end if
C
C  STRG-E (5): Aufruf des EXPLORER.EXE mit dem aktuellen Verzeichnis
C  Version #1 ohne "/select,"
C  Parameter FILES (*.???) werden leider nicht untersttzt
C  bentigt weniger Kapazitt
C  Nachteil: der Explorer springt nicht zur aktuellen Datei
C  Vorteil: funktioniert auch bei Dateinamen mit Leerzeichen
C
C  Experimentell: STRG-E funktioniert
c     if (key.eq.5) then
c       befehl='explorer'
c       befehl(10:)=verz
c       call system (befehl)
c     end if
C
c     if (key.eq.5) then
c       befehl='explorer'
c       if (nblank(verz).eq.2.and.verz(2:2).eq.':') then
c         befehl(nblank(befehl)+2:)=' ,/e'
c       else if (index(aktfile,':\').gt.0) then
c         befehl(16:)=aktfile(1:letzt(aktfile,'\')-1)
c       else
c         befehl(16:)=verz
c       end if
c       call system (befehl)
c     end if
C
C  STRG-E (5): Aufruf des EXPLORER.EXE des aktuellen Verzeichnisses
C  mit der aktuellen Datei, markiert
C  Version #2 mit "/select,"
C
      if (key.eq.5) then
        befehl='explorer'
        if (aktfile.eq.'..') then
          befehl(nblank(befehl)+2:)=verz
        else
          befehl(nblank(befehl)+1:)=' /select,'//aktfile
        end if
        call system (befehl(1:nblank(befehl)))
        isn=.true.
      end if
C
C  Strg-F   (6): Schnellsprung zu Datei mit passender Zeichenkette
C  Alt-F (1033): rckwrts suchen
C
351   if (key.eq.6.or.key.eq.1033.or.parf.and.key.eq.1089) then
c351   if (key.eq.6.or.key.eq.1033
c     *.or.merkfind.ne.' '.and.key.eq.1089) then
        call schnell (datei,imax,marke,merkfind,parf,key,*1)
c       call schnell (datei,imax,marke,merkfind,key,*1)
        parf=.false.
c       merkfind=' '
        isn=.false.
      end if
C
C  Fr Anfangsbuchstaben und -ziffern, Raute, Strg-F,
C  STRG-Cursor oben, STRG-Cursor unten, TAB, Shift-TAB:
C  Sprung durchfhren
C
      if (key.ge.97.and.key.le.122.or.key.ge.48.and.key.le.57
     *.or.key.eq.35.or.key.eq.1141.or.key.eq.1145
     *.or.key.eq.9.or.key.eq.1015.or.key.eq.6.or.key.eq.1033) then
        if (marke.ge.minmarke.and.marke.le.maxmarke) goto 200
        goto 100
      end if
C
C  Laufwerk- und Verzeichnis-Wechsel-Funktionen
C
C  Laufwerks-Wechsel mit Shift-A bis Shift-Z (Grobuchstaben)
C
      if (key.ge.65.and.key.le.90) then
        merkverz=verz
        merkkrit=files
        zurueck=.TRUE.
        verz=char(key)
        verz(2:)=':'
        isn=.FALSE.
        call verzwechsel (verz)
        parf=.false.
        goto 111
      end if
C
C  Darstellung der verfgbaren Laufwerke
C
C  STRG-F10 (1103)   : sofortige Laufwerksanzeige
C  Backspace BSPC (8): Wechsel von <LW>:\ zur Laufwerksanzeige
C
350   if (key.eq.1103
     *.or.key.eq.8.and.nblank(verz).eq.3.and.verz(2:3).eq.':\') then
        write (*,*) '[2;f Lese Laufwerke...'
        merkverz=verz
        merkkrit=files
        zurueck=.TRUE.
        if (verz(2:2).eq.':') then
          verz(3:)=' '
        else
          verz='C:'
        end if
        merkdate=verz
c       befehl='net use>C:\DIR.TMP'
c       call system (befehl)
c       open (11,file='C:\DIR.TMP')
        do i=1,26
          mkt(i)=' '
          datei(i)=char(i+64)
          datei(i)(2:)=':'
C  Mit i ab 3 werden A: und B: ausgeschlossen, da es nervt
          if (i.ge.3) call laufwerke (datei(i))
          if (datei(i)(1:2).eq.merkdate) marke=i
          bytes(i)=-1
          datum(i)=' '
          zeit1(i)=0
          zeit2(i)=0
        end do
c       close (11)
        imax=26
        altm=1
        minmarke=1
        files='*.*'
        parf=.false.
        isn=.false.
        goto 1
      end if
C
C  Backslash "\" (92): Wechsel in das Hauptverzeichnis
C
      if (key.eq.92) then
        merkdate=verz
        verz(2:)=':\'
        files='*.*'
        isn=.FALSE.
        goto 109
      end if
C
C  Backspace BSPC (8): Wechsel in das bergeordnete Verzeichnis
C  Enter (13) bei "..": Wechsel in die nchst hhere Ebene
C
      if (key.eq.8.and.nblank(verz).gt.3
     *.or.key.eq.13.and.aktfile(1:2).eq.'..') then
        isn=.FALSE.
        merkdate=verz(letzt(verz,'\')+1:)
        if (index(merkdate,'~').gt.0) merkdate=merkverz
C  erforderlich
        files=merkkrit
        verz='..'
c       call verzwechsel (verz)
        call system ('cd..')
        parf=.false.
        goto 111
      end if
C
C  Enter (Verzeichnis): Wechsel in das gewhlte Unterverzeichnis
C  Windows NT4 bentigt den Laufwerksbuchstaben
C  Da A: und B: mssen erlaubt sein. Es gibt aber ein Problem,
C  wenn das Laufwerk nicht bereit ist.
C
      if (key.eq.13.and.isv) then
        if (aktfile.eq.' ') goto 300
        zurueck=.false.
c       if (aktfile(1:3).eq.'A: '.or.aktfile(1:3).eq.'B: ') goto 300
c       if (datei(marke)(2:2).eq.':'.and.nblank(datei(marke)).eq.2
c    *  .and.index('A:B:',datei(marke)(1:2)).eq.0) goto 300
C  Von der obersten Laufwerksebene zur Laufwerksbersicht
        if (verz(2:3).eq.':\'.and.nblank(verz).eq.3
     *  .and.aktfile.eq.'..') then
          key=1103
          goto 350
        end if
C  Wechsel in das gewhlte Unterverzeichnis
        if (aktfile(1:2).ne.'..') then
C  Hier: Merkdate fr Alt-F8, Cursor soll auf Fallnummer springen
          merkdate=fall
C  Dateikriterium setzen
C  files(1:4)* statt *.*, da sonst zu viele Dateien
          merkkrit=files
          files='*.*'
          if (aktfile(1:3).eq.'REC'.or.aktfile(3:7).eq.'DATEN')
     *    files=fall(1:4)//'*.*'
C  Verzeichnisname fr Rcksprung zum bergeordneten Verzeichnis
C  merken
C  Aber: bei Rcksprung mit TAB wird das alte Verzeichnis gelesen
          merkverz=aktfile
C  /5: VERZ muss angepasst werden, wenn Verzeichnisse z.B. ??DATEN
C  angezeigt werden sollen und dann mit ENTER hineingewechselt wird
C  Bei /5 soll merkdate nicht FALL sein, siehe weiter oben zu Alt-F8
          if (index(param,'/5').gt.0) then
            merkverz=verz
            merkdate=aktfile
            zurueck=.true.
C  Fallbezogene Auswahl
C  31er Flle werden 8-stellig, 30er Flle 6-stellig gespeichert.
            if (fall(1:2).eq.'30') then
              files=fall(3:)//'*.*'
            else
              files=fall//'*.*'
            end if
          end if
        end if
C  Die aktuelle Datei (d.h. Ordner) wird zum Verzeichnis
        verz=aktfile
C  Von Laufwerksauswahl aus immer Hauptverz. und alle Dateien anzeigen
c       if (verz(2:2).eq.':'.and.nblank(verz).eq.2) then
c         verz(3:)='\'
c         files='*.*'
c       end if
        isn=.FALSE.
        goto 109
      end if
C
C  Beenden
C
C  Enter (Datei): Datei in AUSWAHL.AUS schreiben und Programmende
C  Hier absichtlich nicht DOSWAHL.AUS wegen Kompatibilitt zu REKO
C
      if (key.eq.13.and..not.isv) then
        if (imax.eq.0.or.aktfile.eq.' ') goto 300
        call cls
C  Abfrage
        write (*,10) aktfile
10      format ('  Gewhlte Datei: ',A/,
     *  '  (schreibe Dateinamen in AUSWAHL.AUS)'/,
     *  '  Datei verwenden und DOSWAHL beenden (J/N)?')
        call askjn (*699)
C  Dateiname komplett mit Laufwerk und Verzeichnis
        befehl=' '
        if (index(aktfile,'\').gt.0) then
          befehl=aktfile
        else
          befehl=verz
          i=nblank(verz)
          if (verz(i:i).ne.'\'.and.verz.ne.' ')
     *    befehl(nblank(befehl)+1:)='\'
          befehl(nblank(befehl)+1:)=aktfile
        end if
C  Wechsel zum Reko-Verzeichnis
        call verzwechsel (reko)
C  AUSWAHL.AUS erstellen
        open (13,file='AUSWAHL.AUS')
        rewind (13)
C  Kontrollausgabe
c       print *,befehl
        write (13,'(A)') befehl(1:nblank(befehl))
        close (13)
C  Fr den Parameter /8:xxx
c       if (isb.gt.0) call beginn (param(isb+3:))
        stop
699   end if
C
C  ESC: zurck zur gemerkten Ansicht oder beenden
C
      if (key.eq.27) then
        if (zurueck) then
c         if (merkverz.ne.' ') verz=merkverz
          verz=merkverz
          merkverz=' '
          files=merkkrit
          zurueck=.False.
          strgf9=' '
          opt=' '
          isn=.false.
          goto 109
        end if
        if (zurueck2) then
          call system ('copy c:\dir1.tmp c:\dir.tmp')
          zurueck2=.False.
          isn=.true.
          goto 109
        end if
        goto 99
      end if

C  STRG-Q (17): sofort beenden, aktuelles Verzeichnis wird beibehalten
C  Alt-Q: sofort beenden mit Verzeichniswechsel zu REKO

      if (key.eq.17) goto 999
      if (key.eq.1016) then
        call verzwechsel (reko)
        goto 999
      end if
C
C  STRG-Enter (10): Datei mit "dateiname" ausfhren
C  Ohne CMD, daher nur fr DOS-Programme.

      if (key.eq.10) then
        call cls
        befehl=aktfile
        call system (befehl)
        call pause
        isn=.true.
      end if
C
C  ZURCK ZUR ANZEIGE DER DATEIEN/VERZEICHNISSE
C
C  Zeile 111: Daten neu einlesen (isn = false)
C  Zeile   1: Daten behalten     (isn = true)
C
      if (.not.isn) goto 111
      goto 1
C
C  Programmende
C
99    if (.not.isp) then
C  Nicht bei Strg-* (isn=.true.)
        if (isn) then
          isn=.false.
          goto 111
        end if
        call position (1)
        write (*,*) ' DOSWAHL beenden (j/n)?'
        call askjn (*1)
      end if
C  Wechsel zum ursprnglichen Laufwerk und Verzeichnis
      call verzwechsel (reko)
C  In AUSWAHL.AUS wird eine Leerzeile geschrieben
      open (13,file='AUSWAHL.AUS',err=99)
      rewind (13)
      write (13,'(A)')
      close (13)
C  Bildschirm lschen
999   continue
C  fr den Parameter /8:xxx
c     if (isb.gt.0) call beginn (param(isb+3:))
      if (.not.isp) call cls
      stop
      end
C
C  Strg-F10: Laufwerke und Bezeichnungen finden
C
      subroutine laufwerke (datei)
      integer*2 nblank,letzt,i
      character*(*) datei
      character*80 befehl
      logical ok
C  Laufwerks-Existenz-Abfrage
      datei(3:)='\NUL'
      inquire (file=datei,exist=ok)
      datei(3:)=' '
      if (.not.ok) return
C  Verknpfungsname im Netzwerk
c     rewind (11)
c     befehl=' '
c     do while (index(befehl,datei(1:2)).eq.0)
c       read (11,'(A)',end=350) befehl
c     end do
c     datei(4:)=befehl(index(befehl,'\\'):)
c     i=index(datei,'Microsoft')
c     if (i.gt.0) datei(i:)=' '
C  Volume-Informationen
C  Hier call SYSTEM und nicht call SYSTEM1
350   befehl='vol'
      befehl(5:)=datei
      befehl(8:)='>C:\TEMP\VOL.TMP'
      call system (befehl)
      open (10,file='C:\TEMP\VOL.TMP',err=360)
C  Datentrger-Bezeichnung (nur, wenn es kein Netzlaufwerk ist)
      read (10,'(/A)',end=360) befehl
      i=nblank(befehl)
      if (befehl(i:i).eq.'.') befehl(i:)=' '
      i=letzt(befehl,' ')
      if (index(datei,'\\').eq.0) datei(4:)=befehl(i+1:)
C  Datentrger-Seriennummer (wenn die Netzlaufwerkbezeichnung
C  kurz genug ist). Deaktivierbar bei Kapazittsproblemen
      read (10,'(A)',end=360) befehl
      i=index(befehl,':')
      if (datei(42:).eq.' '.and.befehl(i+2:).ne.' ')
     * datei(42:)=befehl(i+2:)
360   close (10)
C  Fertig
      return
      end
C
C  Laufwerk- und Verzeichniswechsel
C  Problem: Verzwechsel funktioniert berhaupt nur mit SYSTEM,
C  dann aber werden lange Dateinamen oder mit Leerzeichen nicht erkannt
C  Bei Verwendung von SYSTEM1 (cmd/c) erfolgt kein Verzeichniswechsel.
C
      subroutine verzwechsel (verz)
      character*(*) verz
      character*78 befehl
      integer*2 i,nblank
      if (verz.eq.' ') return
C  Laufwerks-Wechsel
      i=index(verz,':')
      if (i.eq.2) then
        befehl=verz(1:2)
        call system (befehl)
      end if
C  strende Ausgabe des Ordners verhindern, wenn nur Laufwerkswechsel
      if (verz(2:).ne.':'.or.nblank(verz).ge.3) then
        befehl='CD '
        befehl(4:)=verz
        call system (befehl)
      end if
C  Zurck
c     print*,verz
c     call pause
      return
      end
C
C  STRG-F (6)   : Schnellsprung zu Datei mit passender Zeichenkette
C  ALT-F  (1033): rckwrts suchen
C  Es kommt nicht mehr auf Gro-/Kleinschreibung an.
C
      subroutine schnell (datei,imax,marke,merkfind,parf,key,*)
c     subroutine schnell (datei,imax,marke,merkfind,key,*)
c     farbe,fmark
      integer*2 imax,marke,i,nblank,key
c     character *5 farbe,fmark
      character *(*) merkfind
      character *(*) datei(imax)
      character *12 upper,udatei
      logical parf
C  Eingeben
      if (merkfind.eq.' ') then
100     call position (1)
        write (*,*) ' Finde Datei:                          [2;15f'
c       call input (12,merkfind,len(merkfind),farbe,fmark,*99,*100)
        read (*,'(A)',end=99) merkfind
        if (merkfind.eq.' ') return 1
      end if
C  Ohne CMD bentige ich UPPER dringend
C  Mit CMD bedeutet UPPER: keine Unterscheidung Gro-Klein
C  Nach dem "end if" fr PARF erforderlich
      merkfind=upper(merkfind)
C  Datei finden
      i=marke+1
      if (i.ge.imax) i=1
      if (key.eq.1033) then
        i=marke-1
        if (i.le.1) i=imax
      end if
      if (parf) i=1
c     if (merkfind.ne.' ') i=1
      do while (i.le.imax.and.i.ge.1)
        udatei=upper(datei(i))
        if (index(udatei,merkfind(1:nblank(merkfind))).gt.0) then
          marke=i
          goto 200
        end if
C  Dies hier absichtlich nicht nur fr key=6, auch fr key=1089
C  (Shift-F6)
c       if (key.eq.6) i=i+1
        if (key.eq.1033) then
          i=i-1
        else
          i=i+1
        end if
      end do
200   return
99    return 1
      end
C
C  Num-Plus-Taste  (key=43): Markieren mit Kriterium
C  Num-Minus-Taste (key=45): Demarkieren mit Kriterium
C
      subroutine markieren (datei,mkt,imax,key,merkmark,bytes)
c     farbe,fmark
      integer*2 i,imax,key,nblank,j,k
c     integer*2 zmax
      character *1 mkt(imax)
      character *2 lw
c     character *5 farbe,fmark
      character *12 ziel,merkmark
      character *11 mtxt
      logical mit
      character *(*) datei(imax)
      character *12 udatei,upper
      integer bytes(imax)
C  Voreinstellung
C  *.* statt files lst das Problem mit cmd, dass Markieren nach einer
C  Dateiauswahl nicht markiert denn es kommt auf Gro/Kleinschreibung an
      if (merkmark.eq.' ') merkmark='*.*'
      ziel=merkmark
      mtxt='markieren'
      if (key.eq.45) mtxt='demarkieren'
100   call cls
      write (*,50) upper(mtxt),mtxt(1:nblank(mtxt)),ziel(1:nblank(ziel))
50    format ('  ',A,//,
     *'  Beachte Gro-/Klein. Laufwerk/Verzeichnis nicht angeben.'/,
     *'  Platzhalter "*" erlaubt. Enter alle Dateien.'/,
     *'  Zu ',A,'de Dateien [',A,'] :')
c    *'  Editierbare Eingabezeile (Hilfe: F1).'/)
C  Ziel abfragen
C  ":" erlaubt um Uhrzeit markieren zu knnen
c     call input (25,ziel,len(ziel),farbe,fmark,*99,*100)
      read (*,'(A)',end=99) ziel
c     if (ziel.eq.' ') goto 99
      if (ziel.eq.' ') ziel=merkmark
      if (index(ziel,'\').gt.0) goto 100
      merkmark=ziel
C  Abfrage Dateien mit oder ohne Verzeichnisse markieren
C  Wenn weiter unten keine Abfrage erfolgt, soll mit=.true. sein.
      mit=.true.
      lw=datei(1)(1:2)
C  Aus Kapazittsgrnden deaktivierbar
      if (lw(2:2).eq.':') then
        write (*,*) ' Alle (Enter) oder ',lw,'*.* (ESC, ohne *.SIC) ',
     *  mtxt(1:nblank(mtxt)) ,'?'
      else if (lw.eq.'..') then
        write (*,*) ' Mit (Enter) oder ohne Verzeichnisse (ESC) ',
     *  mtxt(1:nblank(mtxt)) ,'?'
      else
        goto 201
      end if
      call askjn (*200)
      goto 201
200   mit=.false.
201   continue
C  Platzhalter * und ?
C  wird nicht bentigt, besseres Vorgehen mit den Variablen j und k
c     call platzhalter (ziel)
c     print *,ziel
c     call pause
C  UPPER ist nur erforderlich OHNE CMD, kann aber aus Kapazittsgrnden
C  deaktiviert werden (dann kommt es auf Gro-/Kleinschreibung an)
C  Wenn mit upper, dann udatei statt datei(i)
      ziel=upper(ziel)
C  Markierung setzen
C  Nicht "..", das ist ungnstig z.B. zum Kopieren (dann wrde
C  auch das bergeordnete Verzeichnis kopiert)
C  Beispiele: rec*, rec*.kdt, *.dat
      j=index(ziel,'*')
      k=nblank(ziel)
      do i=1,imax
C  Wenn mit upper, dann udatei statt datei(i)
c       udatei=datei(i)
        udatei=upper(datei(i))
        if ((ziel.eq.'*.*'.or.ziel.eq.'*').and.udatei(1:2).ne.'..'
     *  .or.udatei(1:j-1).eq.ziel(1:j-1).and.k.eq.j
     *  .or.udatei(1:j-1).eq.ziel(1:j-1).and.k.gt.j
     *  .and.index(udatei,ziel(j+1:k)).gt.0
     *  ) then
          if (mit.or.
C  Markieren aller Dateien oder nur Dateien aus lw:
     *    lw(2:2).eq.':'.and..not.mit.and.udatei(1:2).eq.lw
     *    .or.
C  Markieren mit oder ohne Verzeichnisse
c    *    lw(2:2).ne.':'.and..not.mit.and.index(udatei,'<DIR>').eq.0
     *    lw(2:2).ne.':'.and..not.mit.and.bytes(i).ge.0
     *    ) then
            if (key.eq.43) then
              if (mit.or..not.mit.and.index(udatei,'.SIC').eq.0)
     *        mkt(i)='*'
            else if (key.eq.45) then
              mkt(i)=' '
            end if
          end if
        end if
      end do
C  Ende
      call cls
99    return
      end
C
C  Platzhalter * und ?
C
c      subroutine platzhalter (ziel)
c      character *(*) ziel
c      integer*2 i
cC  Platzhalter "?"
cC  zu tun: Bercksichtigung des Platzhalters "?" funktioniert nicht
cc     do i=1,len(ziel)
cc       if (ziel(i:i).eq.'?') ziel(i:i)=' '
cc     end do
cC  Platzhalter "*"
c      if (ziel.ne.'*.*') then
cC  AUS*.* wird zu AUS
c        i=index(ziel,'*.*')
c        if (i.gt.0) then
c          ziel=ziel(1:i-1)
cC  DOSWAHL.* wird zu DOSWAHL
c        else
c          i=index(ziel,'.*')
c          if (i.gt.0) ziel=ziel(1:i-1)
cC  *.FOR wird zu FOR
c          i=index(ziel,'*.')
c          if (i.gt.0) ziel=ziel(i+2:)
c        end if
c      end if
c      return
c      end
C
C  AKTIONEN
C  Kopieren/Umbenennen/Lschen/Verschieben/Drucken/Attribute
C  (hie frher SUBROUTINE KOPIEREN)
C
C  F5        (1063): Aktuelle Datei kopieren
C  Strg-F5   (1098): Aktuelle Datei Attribute setzen
C  F6        (1064): Aktuelle Datei umbenennen
C  Alt-F6    (1109): Aktuelle Datei verschieben
C  F7        (1065): Aktuelle Datei drucken
C  Entf      (1083): Aktuelle Datei lschen (nach C:\TEMP verschieben)
C  Strg-Entf (1147): Aktuelle Datei lschen (endgltig)
C
      subroutine aktionen (marke,merkziel,datei,mkt,anzmkt,imax,
     *key,isv,aktfile,prn,verz,fall,bytes,*)
c    *zwdatei,farbe,fmark
      integer*2 i,j,nblank,anzmkt,imax,key,marke,letzt,ixkey
      integer bytes(imax)
      character *1 mkt(imax),ch
c     character *5 farbe,fmark
      character *51 ziel,neuziel,name
      character *(*) merkziel,verz,aktfile,prn,fall
      character *150 befehl
      character *(*) datei(imax)
      logical isv,ok,mark,alle,iszv
c     logical isdir
      if (aktfile.eq.' ') return
C  Ziel bestimmen
      ziel=' '
c     if (merkziel.ne.' '.and.key.ne.1064) ziel=merkziel ! key=1064 s.u.
      if (anzmkt.eq.0) ziel=aktfile
      if (merkziel.ne.' ') ziel=merkziel
      if (key.eq.1064) then
        ziel=ziel(letzt(ziel,'\')+1:)
C  SIC-Dateien gibt es nur bei 8-stelligen Fallnummern (nicht 5-stellig)
        if (index(aktfile,'.SIC').gt.0) ziel=fall(3:8)
      end if
      if (key.eq.1065) then
        ziel=prn
        if (prn(1:3).eq.'LPT') ziel=prn(1:3)
      end if
      if (key.eq.1098) ziel='-h -r -s -a'
C  Bildschirmausgaben
C  bei Kapazittsproblemen vereinfachbar
100   call cls
      write (*,'(A,A)') '  Datei/Ordner: ',aktfile(1:nblank(aktfile))
      if (anzmkt.eq.0) then
c       if (isv) then
c         write (*,'(A,A)')
c    * '  Ordner: ',aktfile(1:nblank(aktfile))
c       else
c         write (*,'(A,A)')
c    * '  Datei : ',aktfile(1:nblank(aktfile))
c       end if
      else
        write (*,'(A,I4)') '  Markiert sind : ',anzmkt
      end if
C  Bearbeitete Datei optional demarkieren
C  Nur fr Kopieren oder Drucken
C  Sonst nicht, da das Verzeichnis neu eingelesen werden muss,
C  um die Dateiliste zu aktualisieren, und dabei die Markierung
C  zurckgesetzt wird.
C  Diese Option kann bei Kapazittsproblemen entfallen,
C  ich empfehle dann mark=.true. zu setzen.
      mark=.true.
c      if ((key.eq.1063.or.key.eq.1065).and.anzmkt.gt.0) then
c        if (key.eq.1063.or.key.eq.1065) write (*,*)
c     *  ' Markierung nach dem Kopieren/Drucken beibehalten (J/N)?'
c        mark=.false.
c        call askjn (*150)
c        mark=.true.
c150   end if
C  Lschen (ENTF/Strg-Entf)
C  Vor dem endgltigen Lschen Sicherung erstellen,
C  diese kann mit STRG-V wieder eingefgt werden.
C  Man lsche dennoch immer mit ENTF (statt strg-entf), so wird nmlich
C  die aktuelle Datei immer nach C:\TEMP copiert und dann erst gelscht.
      if (key.eq.1083.and.verz.eq.'C:\TEMP') key=1147
      if (key.eq.1147) then
C  Aus Kapazittsgrnden vereinfacht
c       if (anzmkt.eq.0) then
c         write (*,*) ' Nach C:\TEMP\AUSWAHL.CLP verschieben (J/N)?'
c         call askjn (*99)
c         call zwischenablage (aktfile,isv,3,zwdatei,*200)
c       else
C  Da "rd/s" selber noch einmal nachfragt, nur fr Dateien ntig
C  Zur Sicherheit aber immer fragen
c         if (.not.isv) then
            write (*,*) ' Datei endgltig lschen (J/N)?'
            call askjn (*99)
c         end if
c       end if
        goto 200
      else if (key.eq.1083) then
        write (*,'(A)') '  In Papierkorb C:\TEMP verschieben (J/N)?'
        call askjn (*99)
        inquire (file='C:\TEMP\NUL',exist=ok)
        if (.not.ok) call system ('md C:\TEMP')
        goto 200
C  Kopieren/Umbenennen/Verschieben
      else
C  Besonderheit fr Reko
c       if (key.eq.1063.or.key.eq.1109)
c    *write (*,'(A/)') '  \ am Ende: Fall-Verzeichnis wird angehngt.'
C  Normal
c       if (key.eq.1063.and.isv)
c    *write (*,*) ' Angabe ohne Quellverzeichnis.'
        if (key.eq.1063) befehl=' Kopieren auf'
        if (key.eq.1064) befehl=' Umbenennen in'
        if (key.eq.1065) befehl=' Drucken auf'
        if (key.eq.1098) befehl=' Attribute ndern'
        if (key.eq.1109) befehl=' Bewegen nach'
        write (*,'(A/1X,A,A,A,A,A)')
     *'  Zurck mit - und Enter.',
     *  befehl(1:nblank(befehl)),' [',ziel(1:nblank(ziel)),']:'
      end if
C  Eingabe des Namens der Zieldatei
c     call input (16,ziel,60,farbe,fmark,*99,*100)
      name=' '
      read (*,'(A)',end=99) name
C  Ziel bernehmen oder neu angeben
      if (name.ne.' ') ziel=name
C  In Anfhrungszeichen setzen, fr Umbenennen u.a.
c     if (key.ne.1098) ziel=adat(ziel)
C  Zurck wenn kein Ziel angegeben, wo erforderlich (nicht bei Entf)
C  Entf wird aber oben bereits umgeleitet
c     if ((key.ne.1147.and.key.ne.1083).and.ziel.eq.' ') goto 99
      if (key.eq.1064.and.name.eq.' ') goto 99
      if (ziel.eq.' '.or.ziel.eq.'-') goto 99
C  Gemerktes Ziel (Kopieren F5 oder Verschieben Alt-F6)
      if (key.eq.1063.or.key.eq.1109) merkziel=ziel
C  Auf sich selbst kopieren ist nicht erlaubt
C  mit READ statt INPUT: zurck; sonst ist nur Abbruch mit STRG-C
C  mglich, was aber gleichzeitig das Beenden von DOSWAHL zur Folge hat
      if (ziel.eq.aktfile) goto 99
c     if (ziel.eq.aktfile) then
c       write (*,'(A)') '  Ziel und Quelle drfen nicht gleich sein.'
c       call pause
c       goto 100
c     end if
C  Ist das Ziel ein Verzeichnis?
C  Ist richtig, fhrt aber zu STACK OVERFLOW
c     iszv=isdir(upper(ziel))
c     end if
C  Ist das Ziel ein Verzeichnis?
C  Vereinfacht, aber nicht grundstzlich immer richtig.
C  Wenn ein Verzeichnis kopiert wird, muss das Ziel ein Verz. sein.
C  Wenn mehrere Dateien kopiert werden, ist das Ziel genau dann ein
C  Verzeichnis, wenn dort ein : oder \ vorkommt.
C  [oder wenn mehrere Dateien zum Kopieren markiert sind.]
C  [Die letzte Option ist deaktiviert, damit mehrere Dateien auf eine
C  einzelne Datei zusammenkopiert werden knnen.]
C  Die letzte Option ist doch wieder aktiviert, denn das Zusammen-
C  kopieren funktioniert so nicht.
      iszv=.false.
      if (isv) iszv=.true.
c     if ((index(ziel,':').gt.0.or. index(ziel,'\').gt.0)
c    *.and.index(ziel,'*').eq.0.and.index(ziel,'?').eq.0
      if (index(ziel,':').gt.0.or. index(ziel,'\').gt.0
     *.or.anzmkt.gt.0) iszv=.true.
c      if (key.ne.1098.and.anzmkt.gt.0) then
c        write (*,*) ' Ist das Ziel ein Verzeichnis (J/N)?'
c        iszv=.false.
c        call askjn (*120)
c        iszv=.true.
c120   end if
C  F6-Umbenennen: Kontrollen
      if (key.eq.1064) then
c       if (index(ziel,':').gt.0.or.index(ziel,'\').gt.0) then
c         write (*,*) ' Laufwerks- und Verzeichnisangabe nicht erlaubt.'
c         call pause
c         goto 100
c       end if
C   Normale Dateiansicht
        call existbereits (ziel,*100)
C   Dateiansicht mit Pfadangaben
        befehl=aktfile
        befehl(letzt(befehl,'\')+1:)=ziel
        call existbereits (befehl,*100)
      end if
C
C  Eigentlicher Vorgang Kopieren / Umbenennen / Verschieben / Lschen
C
C  isv  = 0 fr zu kopierende Dateien
C  isv  = 1 fr zu kopierende Verzeichnisse
C
200   alle=.false.
      do i=1,imax

        aktfile=datei(i)
        if (anzmkt.eq.0.and.aktfile.eq.datei(marke)
     *  .or.anzmkt.gt.0.and.mkt(i).eq.'*') then
          if (aktfile(1:2).eq.'..') goto 300
          isv=.FALSE.
c         if (index(datei(i),'<DIR>').gt.0) isv=.TRUE.
          if (bytes(i).eq.-1) isv=.TRUE.
C
C     Kommandos
C     Kopieren (1063): wenn Dateien markiert sind (anzmkt>0) -> COPY;
C     wenn nichts markiert ist -> COPY (man kann auch XCOPY nehmen)
C     Verzeichnisse (isv=true) immer mit XCOPY kopieren.
C
          befehl=' '
C     Kopieren F5
          if (key.eq.1063) then
            if (isv) then
              befehl='XCOPY'
            else
              befehl='COPY'
            end if
          end if
C     Attribute ndern/setzen Strg-F5 (1098)
          if (key.eq.1098) then
            befehl='attrib'
          end if
C     Umbenennen F6 (1064)
C     Verschieben Alt-F6 (1109)
C     Unterscheiden, ob Datei (.not.isv) oder Verzeichnis (isv)!
          if (key.eq.1064.and..not.isv) befehl='REN'
          if (key.eq.1064.and.isv.or.key.eq.1109) befehl='MOVE'
C     Drucken F7 (1065)
          if (key.eq.1065) befehl='DRUCKEN.EXE'
C     Lschen endgltig Strg-Entf (1147)
          if (key.eq.1147) then
            if (isv) then
              befehl='deltree'
            else
              befehl='DEL'
            end if
          end if
C     Entfernen DEL (1083)
C     (in C:\TEMP endgltig lschen, sonst verschieben nach C:\TEMP)
          if (key.eq.1083) then
            befehl='MOVE'
            befehl(6:)=aktfile
            befehl(nblank(befehl)+2:)='C:\TEMP'
            call system (befehl)
            datei(i)=' '
            goto 300
          end if
C
C     Quelle: Dateiname
C     Quelldatei mit Laufwerk und Pfad
C     DRUCKEN.EXE bentigt den kompletten Pfad, um EXIT.TMP zu
C     erstellen, und um den richtigen Dateityp feststellen zu knnen.
C
          if (key.eq.1065.and.index(aktfile,'\').eq.0) then
            befehl(nblank(befehl)+2:)=verz
            if (letzt(befehl,'\').ne.nblank(befehl))
     *      befehl(nblank(befehl)+1:)='\'//aktfile
          else
            befehl(nblank(befehl)+2:)=aktfile
          end if
C
          neuziel=ziel
C
C   Besonderheit fr COPY/MOVE: Fallnummern-Verzeichnis anhngen,
C   sofern ein "\" am Ende des Ziels angegeben worden ist
C   Funktioniert nicht richtig, daher deaktiviert (Befehl zu lang!)
C
c          if ((key.eq.1063.or.key.eq.1109)
c     *    .and.ziel(nblank(ziel):).eq.'\') then
cc    *    .and.letzt(ziel,'\').eq.nblank(ziel)) then
cC       Entweder die Fallnummer vor dem letzten \ suchen
cc           j=letzt(aktfile,'\')-1
cc           do while (j.ge.1.and.aktfile(j:j).ne.'\')
cc             j=j-1
cc           end do
cc           if (j.gt.0) neuziel(nblank(neuziel)+1:)=aktfile(j+1:)
cC       Oder: Fallnummer folgt aus ersten 10 Zeichen nach dem letzten \
c            j=letzt(aktfile,'\')
c            neuziel(nblank(neuziel)+1:)=aktfile(j+1:j+2)
c            neuziel(nblank(neuziel)+1:)=aktfile(j+5:j+10)
cC       Ende entweder
c          end if
C
C     Kopieren: Quelldateiname anhngen (Dateien/Verzeichnisse)
C     Nicht das ZIEL ndern, sondern NEUZIEL, da sonst bei mehrfachen
C     Kopieren das ZIEL falsch wird
C     Wird fr die folgende Existenzabfrage bentigt.
C
          if (key.eq.1063.and.iszv) then
            j=nblank(ziel)
            if (ziel(j:j).ne.':'.and.ziel(j:j).ne.'\')
     *      neuziel(nblank(neuziel)+1:)='\'//aktfile
          end if
C
C       Prfen auf Existenz und Abfrage
C       Da diese nicht bei langen Namen funktioniert,
C       sinnvolle Verwendung bei CMD=.FALSE. oder kurzen Namen.
C
          if (key.eq.1063.and..not.alle.and..not.isv) then
            inquire (file=neuziel,exist=ok)
            if (ok) then
C       Bei Kapazittsproblemen ganz ohne diese Anzeige
              if (anzmkt.eq.0) then
                call system ('dir '//aktfile)
                call system ('dir '//neuziel)
C       Bei Kapazittsproblemen ohne '|find /v "e"' (mit CMD: e mglich)
c               call system ('dir '//aktfile//'|find /v "e"')
c               call system ('dir '//neuziel//'|find /v "e"')
              end if
C       Entweder so (bentigt weniger Kapazitt)
c             write (*,*) ' Ziel: ',neuziel,
c    *        ' Ziel berschreiben (Ja,alle / Nein)?'
c             call askjn (*300)
c             alle=.true.
C       Oder so (mehr Kapazitt erforderlich), aber deutlich besser
              write (*,*) ' Ziel: ',neuziel,
     *        ' Ziel berschreiben (Ja/Nein/Alle/ESC)?'
290           j=ixkey()
              if (j.eq.27) then
                goto 900                  ! zurck: ESC
              else if (j.eq.97.or.j.eq.65) then
                alle=.true.               ! Alle kopieren: A
              else if (j.eq.110.or.j.eq.78) then
                goto 300                  ! Nein, nur diese nicht: N
              else if (j.eq.13.or.j.eq.106.or.j.eq.74) then
                continue                  ! Ja diese Datei: J/Enter
              else
                goto 290                  ! unerlaubte Tasten
              end if
C       Ende so
            end if
          end if
C
C     Befehl um Ziel ergnzen (nicht fr Lschen)
C
          if (key.eq.1065) then
            befehl(nblank(befehl)+2:)='/2/3:'//neuziel
          else if (key.ne.1147.and.key.ne.1083) then
            befehl(nblank(befehl)+2:)=neuziel
          end if
C     Option beim Kopieren von Verzeichnissen und Dateien
C     xcopy=/-Y hat den Nachteil, dass bei mehreren markierten Dateien
C     auch bei Antwort "a" (alle) jede Datei einzeln besttigt werden
C     muss.
C     Daher dies hier deaktiviert, INQUIRE (oben) dafr auch mit CMD.
          if (key.eq.1063) then
            if (isv) befehl(nblank(befehl)+2:)='/S/E'
c           if (cmd) befehl(nblank(befehl)+2:)=xcopy
          end if
C
C     Ausgabe (nicht beim Drucken, da dies DRUCKEN.EXE erledigt)
C     Auch nicht bei Strg-Entf fr Ordner, das "rd/s" ihn auch anzeigt
C     Gegenteil von: "if (key.eq.1065.or.(key.eq.1147.and.isv))"
C     Das Steuerzeichen "+" verhindert berflssigen Zeilenvorschub
C
          if (key.ne.1065.and.(key.ne.1147.or..not.isv)) then
            ch=' '
            if (key.eq.1063) ch='+'
            write (*,'(A1,A)') ch,befehl(1:nblank(befehl))
          end if
C
C     Allgemein, aber besonders wichtig beim Umbenennen:
C     Warnung wenn Befehlskette > 77 Zeichen (Compilergrenze)
C     Deaktiviert, da bei Umleitung zu RENTMP.BAT nicht erforderlich
C
c         j=77
c         if (cmd) j=72
c         if (nblank(befehl).gt.j) then
c           write (*,'(/A,I3/A/2X,A/A)')
c    *      '  77 Zeichen erlaubt. Befehl ist zu lang: ',nblank(befehl),
c    *      '  Ausfhrbarer Befehl:',befehl(1:j),
c    *      '  Dennoch ausfhren (J/N)?'
c           call askjn (*300)
c         end if
C
C     Umbenennen: in BATCH-Datei umleiten, da nur so lange Dateinamen
C     umbenannt werden knnen
C     RENTMP.BAT wird aus dem aktuellen Verzeichnis aufgerufen und kann
C     doch selber in C:\TEMP sein, da keine Pfadangaben bergeben werden
C
          if (key.eq.1064) then
            open (12,file='C:\TEMP\RENTMP.BAT')
            rewind (12)
            write (12,'(A/A)') '@echo off',befehl
            close (12)
            befehl='C:\TEMP\RENTMP.BAT'
          end if
C
C     Ausfhren
C
c         print *,befehl
c         call pause
          call system (befehl)
C
C     ANZMKT muss beibehalten werden, denn sonst wird auch die Datei
C     bearbeitet, auf die der Cursor nach dem Markieren steht.
c         if (.not.mark.and.(key.eq.1063.or.key.eq.1065)) then
          if (.not.mark) then
            mkt(i)=' '
c           anzmkt=anzmkt-1
          end if
C
C     Name einer gelschten oder verschobenen Datei entfernen
          if (key.eq.1147.or.key.eq.1083.or.key.eq.1109) datei(i)=' '
C     F6: Name einer umbenannten Datei gleich anzeigen
C     (da bei "/2 vorhanden" = ISN nicht neu eingelesen werden darf)
          if (key.eq.1064) then
            j=letzt(datei(i),'\')
C      vereinfacht
            datei(i)(j+1:)=neuziel
C      deaktiviert
c           if (index(neuziel,'*').eq.0) datei(i)(j+1:)=neuziel
c           if (index(neuziel,'*').eq.0) then
c             datei(i)(j+1:)=neuziel
c           else
c             j=index(datei(i),'  ')
c             datei(i)(j:)=neuziel(index(neuziel,'*')+1:)
c           end if
          end if
        end if
300   end do
C
C  RENTMP.BAT braucht aus C:\TEMP nicht gelscht werden
c     inquire (file='C:\TEMP\RENTMP.BAT',exist=ok)
c     if (ok) call system ('del C:\TEMP\RENTMP.BAT')
c     if (ok) then
c       open (12,file='C:\TEMP\RENTMP.BAT',status='scratch')
c       close (12)
c     end if

      call pause
C
C  Rckkehr: nicht nochmal einlesen, wenn auf ein anderes als das
C  aktuelle Verzeichnis kopiert (1063) oder verschoben (1109) worden ist
C  Ebenso wenn im Dateiname der Pfad steht, Suchaktion nicht wiederholen
C
900   if (iszv.and.(key.eq.1063.or.key.eq.1109)
     *.or.index(datei(marke),'\').gt.0) goto 99
C
C  Fertig
      return
99    return 1
      end
C
C  Ist das Ziel ein Verzeichnis?
C  Wenn ja, wird es in der Ausgabe des DIR-Befehls erscheinen,
C  die das Verzeichnis enthlt, sonst nicht
C
c      function isdir (ziel)
c      logical isdir
c      character*(*) ziel
c      character*78 temp,befehl
c      integer*2 nblank
c      befehl='dir'
c      befehl(5:)=ziel
c      befehl(nblank(befehl)+2:)='>c:\temp\isdir.tmp'
c      call system (befehl)
c      temp=' '
c      open (10,file='c:\temp\isdir.tmp',err=100)
c      do while (index(temp,'\').eq.0)
c        read (10,'(A)',end=100) temp
c      end do
c100   close (10)
c      isdir=.false.
c      if (index(temp,ziel(1:nblank(ziel))).gt.0) isdir=.true.
c      return
c      end
C
C  F10     (is=0): Auswahl eines Dateikriteriums
C  ALt-F10 (is=1): Auswahl Laufwerk, Verzeichnis und Dateikriterium
C
      subroutine waehlen (verz,files,is,*)
c     farbe,fmark
      character *(*) verz,files
      character *51 name,temp
c     character *5 farbe,fmark
      integer*2 nblank,letzt,i
      logical is
C  Dateikriterium bestimmen
      if (is) then
        name=verz
        name(nblank(name)+1:)='\'//files
      else
        name=files
      end if
C  Abfrage des Benutzers
C  Die version mit CLS ist nicht zulssig, da der Bildschirm gelscht
C  wird. Die dateianzeige der nichtaktiven Spalte muss erhalten bleiben.
c100   call cls
cc     write (*,10) name(1:68)
c      write (*,10) name
c10    format ('  DATEI-AUSWAHL'//,
cc    *'  Editierbare Eingabezeile (Hilfe: F1).'/,
cc    *'  Feld mit ESC leeren und ENTER zeigt alle Dateien an.'/,
c     *'  * zeigt alle Dateien an; Platzhalter "*" und "?" erlaubt.'/,
c     *'  Angabe des Dateiauswahlkriteriums, z.B. *.exe'//,
c     *'  Alte Wahl:',A/,
c     *'  Neue Wahl:')
cc     call input (10,name,68,farbe,fmark,*99,*100)
C  Anzeige nur oben
100   call position (1)
      if (is) then
        write (*,*)' Lw:\Ordner\Dateien:                    [2;22f'
      else
        write (*,*)' Dateien:                               [2;11f'
      end if
C  Ende Anzeige
      read (*,'(A)',end=99) temp
      if (temp.eq.' ') goto 99
      name=temp
C  Kontrolle (kann bei Kapazittsproblemen entfallen)
      if (.not.is) then
c       if (index(name,':').gt.0.or.index(name,'\').gt.0) then
c         write (*,*) ' Laufwerk, Verzeichnis nicht angeben.'
c         call pause
c         goto 100
c       end if
C  Kurzform
        if(index(name,':').gt.0.or.index(name,'\').gt.0) goto 100
      end if
C  Neue Zuordnung
      if (is) then
        if (index(name,'*').gt.0.or.index(name,'?').gt.0) then
          i=letzt(name,'\')
          verz=name(1:i-1)
          files=name(i+1:)
        else
          verz=name
          files='*.*'
        end if
      else
        files=name(1:12)
      end if
C  Ende von "Dateikriterium anpassen"
      return
99    return 1
      end
C
C  Setzen des MODE (Anzahl der Bildschirmzeilen)
C  ZEILEN mssen linksbndig im I2-Bereich stehen;
C  sie stehen aber rechtsbndig, und deshalb sind nur
C  Zeilen = 10 bis Zeilen = 99 zulssig (ab 25 mglich)
C
      subroutine setmode (zeilen)
      integer*2 zeilen
      character *20 befehl
      befehl='mode con lines='
      write (befehl(16:),'(I2)') zeilen
      call system (befehl)
      return
      end
C
C F4      (1062): Ergebnisse einer REKO-Eingabedatei berechnen, anzeigen
C Strg-F4 (1097): Graphik zu einer REKO-Eingabedatei berechnen, anzeigen
C isg = 0 wenn Berechnung erforderlich, isg = 1 wenn nur Graphik
C
      subroutine berech (aktfile,zeilen,typ,key,graphik,*)
      character *78 befehl
      character *(*) aktfile
      character *2 typ
c     integer*2 i
      integer*2 zeilen,nblank,key
      logical graphik
c     logical isg
      call cls
C  Zurck bei Fehler
c     if (typ.eq.' '.or.isg.and.key.eq.1062) then
      if (typ.eq.' '.or.index(aktfile,'RG').gt.0) then
        write (*,'(A//A,A)')
     *  ' BERECHNUNG',
     *  ' Keine Reko-Eingabedatei: ',aktfile
        call pause
        return 1
      end if
C  Befehl ausfhren
c     if (.not.isg) then
        befehl=typ
        befehl(nblank(befehl)+1:)='REKO.EXE'
C  Berechnung
C  Ergebnisdatei kann wegen zu wenig RAM nicht von ??REKO selber
C  angezeigt werden, daher hier /N und hier anzeigen
C  /N bedeutet ohne Anzeige der Ergebnisse innerhalb von ??REKO.EXE
C  Bei Kapazittsproblemen: ohne /N und ohne 'list' ff.
C  ALSO ENTWEDER (mit /N und mit Anzeige der Ergebnisse hier in DOSWAHL)
c        befehl(nblank(befehl)+2:)=aktfile
c        befehl(nblank(befehl)+1:)='/N'
c        if (key.eq.1097) befehl(nblank(befehl)+1:)='/Z/F'
c        call system (befehl)
c        if (key.eq.1062) then
c          befehl='list'
c          befehl(6:)=aktfile
c          i=index(befehl,'.')
c          if (i.gt.0) then
c            if (befehl(i+1:i+2).eq.typ) then
c              befehl(i:)='.ERG'
c            else
c              befehl(i+2:)='RG'
c            end if
c          else
c            befehl(nblank(befehl)+1:)='.ERG'
c          end if
c          call system (befehl)
c          call cls
c        end if
C  ODER (ohne /N und Anzeige der Ergebnisse innerhalb ??REKO.EXE)
C  Vorraussetzung hierfr: F5(DIR) in REKOMENU (REKO.EXE) wird
C  mit "cmd/c start" angezeigt, sonst ist zu wenig RAM vorhanden.
        befehl(nblank(befehl)+2:)=aktfile
        if (key.eq.1097) befehl(nblank(befehl)+1:)='/Z/F'
        call system (befehl)
C  ENDE ENTWEDER
c     end if
C  Graphik darstellen
C  Beispiel: "GRAPHIK KA KAGRAPH.DAT"
      if (key.eq.1097.and.graphik) then
        befehl='GRAPHIK.EXE '//typ//' '//typ//'GRAPH.DAT'
        call system (befehl)
C  Bildschirm-Modus setzen
C  Da GRAPHIK.EXE grundstzlich den 25-Zeilen-Modus beim Beenden
C  liefert, braucht dieser nicht wieder gesetzt zu werden
C  Hier: ohne "isp", da DOSWAHL aus REKO/EINGABE immer mit
C  dem Parameter "/1" aufgerufen wird (wodurch isp=1 gesetzt wird).
C       if (zeilen.ne.0.and..not.isp) then
        if (zeilen.ne.0) call setmode (zeilen)
      end if
C  Pause hier, um anzuzeigen, wenn nicht gengend RAM vorhanden
c     call pause
c     call cls
      return
      end
C
C  F4: Prfen der Korrekturdaten, Aktualisieren der Datenbank-Datei
C  Beispiel: "rec01 REC01.KDT /s/2/F:30050100"
C  Parameter /S: Datenbank-Datei kann aktualisiert werden
C  Parameter /2: kein Datentransfer von der Rekonstruktion
C  Parameter /F:########  achtstellige Fallnummer.
C  Parameter /D: Fall-Datenbankdatei REKO.TXT fallweise anlegen
C  Parameter /R:REKO-Verzeichnis
C
      subroutine kdtpruef (aktfile,rec,typ,reko,jahr,*)
      character *78 befehl
      character *(*) aktfile,reko,rec,typ
      integer*2 nblank,jahr
c     integer*2 konbetei,var
c     integer*2 kollgeg
      call cls
C  Zurck bei Fehler
C  Kann bei Kapazittsproblemen entfallen,
C  da [REC#1.FOR dies selber prft] nein prft er nicht mehr,
C  aber F4 unterscheidet zwischen REKO-Daten und REC-Daten.
C  Nur fr alle anderen Dateien erforderlich.
c     if (rec.eq.' ') then
c       write (*,'(A/A,A)')
c    *  '  KORREKTURDATEN PRFEN',
c    *  '  Keine Record-Korrekturdatei: ',aktfile(1:nblank(aktfile))
c       call pause
c       goto 99
c     end if
C  Kurzform
      if (rec.eq.' ') goto 99
C  Prfung fr zwei miteinander kollidierte Fahrzeuge,
C  Vergleiche auch EINGABE.EXE (aktfile statt kdtfile)
C  Da hier kein Pfad bergeben wird, in REC#1.FOR die Prfung auf
C  "REC??" entfernen.
C  Mit Pfadangabe wird der Quelltext komplizierter als er sein muss,
C  und REC??.EXE funktioniert auch ohne.
      if (rec.eq.'20') then
c        konbetei=0
cc       kollgeg=0
c        open (10,file=aktfile,err=200)
c100     read (10,'(A)',end=200) befehl
c        read (befehl(1:5),'(I5)',err=200) var
c        if (befehl(10:17).eq.'KONBETEI') konbetei=var
cc       if (befehl(10:17).eq.'KOLLGEG ') kollgeg =var
c        goto 100
c200     close (10)
cC  Wenn KOLLGEG vergessen wurde, auch ohne KOLLGEG prfen
cc       if (konbetei.gt.0.and.kollgeg.gt.0) then
c        if (konbetei.gt.0) then
          befehl='REC20ZW.EXE'
C  Wenn alte Fallnummer dann JAHR=0, siehe oben "Fallnummer lesen"
C  Dies muss wenigstens hier in DOSWAHL.EXE erhalten bleiben,
C  da es in EINGABE.EXE absichtlich deaktiviert ist.
          if (jahr.ge.73.or.jahr.le.4) befehl='REC20ZWx.EXE'
          befehl(14:)=aktfile
C  Parameter / erforderlich, damit ignore() in REC#2.FOR ausgefhrt wird
          befehl(nblank(befehl)+2:)='/'
          if (typ.eq.'FG') befehl(nblank(befehl)+1:)='FG'
          call system (befehl)
c         call pause
c         call cls
c        end if
      end if
C  Angabe des Prfprogramms
C  Ohne Existenzabfrage, da REC??.EXE im PATH sein muss
      befehl='REC'
      befehl(nblank(befehl)+1:)=rec
      if (jahr.ge.73.or.jahr.le.4) befehl(nblank(befehl)+1:)='x'
      befehl(nblank(befehl)+1:)='.EXE '//aktfile
      if (index(aktfile,'.KDT').eq.0) then
        befehl(nblank(befehl)+2:)='/S/D/2/R:'//reko
      end if
C  Befehl ausfhren
      call system (befehl)
      call pause
      call cls
      return
99    return 1
      end
C
C  Alt-D: (isv=0) erstelle neue Datei
C  Alt-V: (isv=1) erstelle neues Verzeichnis
C
      subroutine erstell (isv,merkdate,*)
      character *78 befehl
      character *12 name
      character *(*) merkdate
      integer*2 nblank
c     integer*2 i
      logical isv
C  Eigentliche Funktion ausfhren
      call position (1)
      if (isv) then
        write (*,*) ' Neues Verz.(8.3): [2;20f'
      else
        write (*,*) ' Neue Datei (8.3): [2;20f'
      end if
      read (*,'(A)') name
      merkdate=name
      if (name.eq.' ') goto 99
C  Prfen auf Existenz
      call existbereits (name,*99)
C  Verzeichnis erstellen
      if (isv) then
        write (*,*) ' Erstelle Verzeichnis: ',name(1:nblank(name))
        befehl='MD'
C  Datei erstellen
C  REM und ECHO: haben fast den gleichen Effekt;
C  mit REM hat die Datei 0 Byte und mit ECHO: 2 Byte.
      else
        write (*,*) ' Erstelle Datei: ',name(1:nblank(name))
        befehl='rem>'
      end if
      befehl(nblank(befehl)+2:)=name
      call system (befehl)
      return
99    return 1
      end
C
C  Neu
C  Aktuelle und markierte Datei
C  Shift-F6 (1089): Datei vergleichen
C  STRG-F6  (1099): Datei vertauschen
C  T.TMP muss im aktuellen Verzeichnis sein, nicht in c:\ oder c:\temp
C
c      subroutine vergletau (key,aktfile,ziel)
c      character *78 befehl
c      character *(*) aktfile,ziel
c      integer*2 nblank,key
c      logical ok
c      if (key.eq.1089) then
c        befehl='FC'
c        befehl(4:)=aktfile
c        befehl(nblank(befehl)+2:)=ziel
c        befehl(nblank(befehl)+2:)='/N>VGL.TMP'
c        call system (befehl)
c        call system ('LIST VGL.TMP')
c        call cls
c      else
c        call cls
c        inquire (file='T.TMP',exist=ok)
c        if (ok) goto 999
cc       if (ok) then
cc         write (*,*) ' T.TMP bereits vorhanden!'
cc         call pause
cc         goto 999
cc       end if
cc       write (*,'(A,A,A,A,A)')' Vertausche ',
cc   * aktfile(1:nblank(aktfile)),' mit ',ziel(1:nblank(ziel)),' (J/N)?'
cc       call askjn (*999)
c        call rentmp (aktfile,'T.TMP')
c        call rentmp (ziel,aktfile)
c        call rentmp ('T.TMP',ziel)
c        call pause
c      end if
c999   return
c      end
C
C  Temporre Umbenennungsbatch
C
c     subroutine rentmp (datei,ziel)
c     character*(*) datei,ziel
c     integer*2 nblank
c     open (12,file='C:\TEMP\RENTMP.BAT')
c     write (12,'(A,A,A,A,A)')
c    *'ren',' ',datei(1:nblank(datei)),' ',ziel
c     close (12)
c     call system ('C:\TEMP\RENTMP.BAT')
c     end
C
C  Temporre Kopierbatch
C
      subroutine kopier (datei,ziel)
      character*(*) datei,ziel
      integer*2 nblank
      open (12,file='C:\TEMP\KOPIER.BAT')
      write (12,'(A,A,A,A,A)')
     *'copy',' ',datei(1:nblank(datei)),' ',ziel
      close (12)
      call system ('C:\TEMP\KOPIER.BAT')
      end
C
C  Cursor-Positionierung
C
      subroutine position (pos)
      integer*2 pos
      if (pos.le.9) then
        write (*,'(A3,I1,A2)') ' [',pos,';f'
      else if (pos.le.99) then
        write (*,'(A3,I2,A2)') ' [',pos,';f'
c     else if (pos.le.999) then
c       write (*,'(A3,I3,A2)') ' [',pos,';f'
c     else if (pos.le.9999) then
c       write (*,'(A3,I4,A2)') ' [',pos,';f'
      end if
      return
      end
C
C  Bereichsabgrenzung
C
c      subroutine bereich (anzahl,imax,marke,minmarke,maxmarke)
c      integer*2 anzahl,imax,marke,minmarke,maxmarke
cC    Anpassung an genderte Bildschirmzeilen
c      maxmarke=minmarke+(anzahl-1)
cC    Markierung
c      if (marke.lt.1) marke=1
c      if (marke.gt.imax) marke=imax
cC    Nach oben bewegen
c      if (marke.lt.minmarke) then
c        minmarke=marke
c        maxmarke=minmarke+(anzahl-1)
c      end if
cC    Nach unten bewegen
c      if (marke.gt.maxmarke) then
c        maxmarke=marke
c        minmarke=maxmarke-(anzahl-1)
c      end if
cC    Erste und letzte Datei
c      if (minmarke.lt.1) minmarke=1
c      if (maxmarke.gt.imax) maxmarke=imax
cC    Erste Bildschirmseite
c      if (maxmarke.lt.imax.and.imax.le.anzahl) maxmarke=imax
c      return
c      end
C
C  X: DOS
C
c     subroutine dos (farbe)
c     character*5 farbe
c     integer*2 nblank
c     call cls
c     write (*,'(A//)') ' [0m DOSWAHL.EXE: Zurck mit EXIT!'
c     call system ('command')
c     write (*,'(A3,A,A1)') '[',farbe(1:nblank(farbe)),'m'
c     call cls
c     return
c     end
C
C  Prfen der Existenz einer zu lesenden Datei #1
C
      subroutine exist (datei,*)
      character *(*) datei
      logical ok
c     integer*2 nblank
      inquire (file=datei,exist=ok)
      if (.not.ok) then
        call cls
        write (*,*) ' Datei nicht gefunden: ',datei
        call pause
        return 1
      end if
      return
      end
C
C  Prfen der Existenz einer zu lesenden Datei #2
C
      subroutine existbereits (datei,*)
      character *(*) datei
      character *16 temp
      integer*2 nblank
      logical ok,ok2
C  Datei
      inquire (file=datei,exist=ok)
C  Verzeichnis
      temp=datei
      temp(nblank(temp)+1:)='\nul'
      inquire (file=temp,exist=ok2)
C  Meldung
      if (ok.or.ok2) then
c       call cls
        write (*,*) ' Bereits vorhanden: ',datei(1:nblank(datei))
        call pause
        goto 99
      end if
      return
99    return 1
      end
C
C  Das letzte Vorkommen eines Zeichens finden
C
      function letzt (wert,zeichen)
      character *(*) wert
      character*1 zeichen
      integer*2 letzt,i,nblank
      letzt=0
      i=nblank(wert)
      do while (wert(i:i).ne.zeichen.and.i.gt.0)
        i=i-1
      end do
      letzt=i
      return
      end
C
C  Konfigurationsdatei REKO.INI
C
C  isp : =0 direkter Aufruf,         =1 Aufruf mit "/1"
C
      subroutine rekoini (reko,zeilen,anzahl,farbe,fmark,digi,prn,
     *isp,top,belege,graphik,team,dbverz)
c     character *3 xcopy
      character *5 farbe,fmark
c     character *51 editor
      character *(*) digi,belege,prn,team,dbverz,reko
      character *51 text
      integer*2 zeilen,anzahl,nblank,i,j,top
      logical isp,graphik
      graphik=.false.
C  Datei suchen
      text=reko
      text(nblank(text)+1:)='\REKO.INI'
      call exist (text,*99)
C  Datei ffnen und einlesen
      open (13,file=text,err=99)
10    read (13,'(A)',end=20) text
      i=index(text,'=')
      j=index(text,'#')
C  Zuordnung der bentigten Werte
      if (index(text,'#ANSI=1').gt.0) call system ('ansi.com /q')
C  Fr DOSWAHL: dieses deaktivieren (C in Spalte 1 setzen)!
      if (text(j:i).eq.'#REKO='   ) reko  =text(i+1:)
      if (text(j:i).eq.'#PRN='    ) prn   =text(i+1:)
      if (text(j:i).eq.'#FARBE='  ) farbe =text(i+1:)
      if (text(j:i).eq.'#FMARK='  ) fmark =text(i+1:)
c     if (text(j:i).eq.'#XCOPY='  ) xcopy =text(i+1:)
      if (text(j:i).eq.'#DIGI='   ) digi  =text(i+1:)
      if (text(j:i).eq.'#DBVERZ=' ) dbverz=text(i+1:)
      if (text(j:i).eq.'#BELEGE=' ) belege=text(i+1:)
c     if (text(j:i).eq.'#EDITOR=' ) editor=text(i+1:)
      if (text(j:i).eq.'#TEAM='   ) team  =text(i+1:)
      if (text(j:i+1).eq.'#GRAPHIK=1' ) graphik=.true.
      if (text(j:i).eq.'#ZEILEN=' ) then
        read (text(i+1:),'(I2)',err=20) zeilen
      end if
      goto 10
20    close (13)
C  Anzahl der darstellbaren Dateien pro Bildschirmseite
      if (zeilen.ne.0) then
        if (zeilen.lt.25.or.zeilen.gt.99) zeilen=25
        anzahl=zeilen-top-1
      else
        anzahl=25-top-1
      end if
C  Bildschirmfarbe und -modus setzen und Bildschirm lschen
      if (.not.isp) then
        write (*,'(A7,A,A1)') '[0m[',farbe(1:nblank(farbe)),'m'
        if (zeilen.ne.0) call setmode (zeilen)
        call cls
      end if
99    return
      end
C
C  Eingaberoutine zum Editieren eines Textes
C  Hier: gemerkte Zeilen wie in PROG.FOR wrde zu STACK OVERFLOW fhren
C  Aus Kapazittsgrnden deaktiviert, durch READ ersetzt
C
c      SUBROUTINE INPUT (pos,text,laenge,farbe,fmark,*,*)
cC  Definitionen
cC  Bei siebzig Zeichen und Anfangsposition 9 wird gerade eine
cC  Bildschirmzeile komplett ausgefllt (mehr ist nicht sinnvoll)
c      integer*2 key,ixkey,pos,laenge,i,j,nblank
c      character *5 farbe,fmark
c      character *(*) text
c      logical insert
cC  Cursor an das Textende setzen
c      i=nblank(text(1:laenge))
c      if (i.lt.laenge) i=i+1
cC  Initialisierung
c      key=0
c      insert=.FALSE.
cC  Weitere Bearbeitung
c      do while (key.ne.13)
cC  Ausgabe der Zeichenkette ("write" springt zum Anfang der Folgezeile)
cC  Eine Zeile hoch, Stelle merken, Cursor an Textfeldanfang,
cC  andere Farbdarstellung, Ausgabe des Textes, normale Darstellung,
cC  Cursor an gemerkte Stelle, Cursor an aktuelle Position.
c        write (*,'(A,I2,A,A,A,A,A,A,A,I2,A)')
c     *  ' [s[',pos+1,'C[',fmark(1:nblank(fmark)),'m',
c     *  text(1:laenge),'[',farbe(1:nblank(farbe)),'m[u[',pos+i,'C'
cC  Abfrage der Tastatur
c100     key=ixkey()
c        if (key.eq.26.or.key.eq.9) goto 100
cC  bernahme mit ENTER
c        if (key.eq.13) then
c          return
cC  Eingabe mit ESC beenden, wenn Text bereits leer
c        else if (key.eq.27.and.text(1:laenge).eq.' ') then
c          return 1
cC  Vorhandenen Text mit ESC lschen
c        else if (key.eq.27) then
c          text(1:laenge)=' '
c          i=1
cC  Hilfe mit F1
c        else if (key.eq.1059) then
c          call cls
c          write (*,10)
c10        format ('  Hilfe zur Editierbaren Eingabezeile'//,
c     *    '  Enter         : Text bernehmen'/,
c     *    '  Esc           : Abbruch; Text lschen, wenn vorhanden'/,
c     *    '  Cursor li/re  : Markierung bewegen'/,
c     *    '  STRG-li/-re   : Ende letztes / Anfang nchstes Wort'/,
c     *    '  Pos1, Ende    : Zeilenanfang, Zeilenende'/,
c     *    '  STRG-Pos1,Ende: Lschen bis vor, ab Cursor'/,
c     *    '  Entf, Backsp. : aktuelles, vorheriges Zeichen lschen'/,
c     *    '  Einfg (ins)   : Wechsel berschreiben/Einfgen'/)
c          call pause
c          return 2
cC  Cursor links
c        else if (key.eq.1075) then
c          if (i.gt.1) i=i-1
cC  Cursor rechts
c        else if (key.eq.1077) then
c          if (i.lt.laenge) i=i+1
cC  Pos1 (Anfang)
c        else if (key.eq.1071) then
c          i=1
cC  Ende der Zeichenkette
c        else if (key.eq.1079) then
c          i=nblank(text(1:laenge))
c          if (i.lt.laenge) i=i+1
cC  STRG-Cursor rechts: Sprung zum Anfang des nchsten Wortes
c        else if (key.eq.1116) then
c          do while (text(i:i).ne.' ')
c            i=i+1
c          end do
c          do while (text(i:i).eq.' ')
c            i=i+1
c          end do
c          if (i.gt.laenge) i=laenge
cC  STRG-Cursor links: Sprung zum Ende des vorherigen Wortes
c        else if (key.eq.1115) then
c          do while (text(i:i).ne.' ')
c            i=i-1
c          end do
c          do while (text(i:i).eq.' ')
c            i=i-1
c          end do
c          if (i.lt.1) i=1
cC  Entfernen (Zeichen lschen) mit Del/Entf
c        else if (key.eq.1083) then
c          if (i.lt.laenge) text(i:laenge-1)=text(i+1:laenge)
c          text(laenge:laenge)=' '
cC  Zurcklschen mit BACKSPACE
c        else if (key.eq.8) then
c          if (i.gt.1) then
c            text(i-1:laenge-1)=text(i:laenge)
c            text(laenge:laenge)=' '
c            i=i-1
c          end if
cC  STRG-Pos1: Lschen ab Textanfang bis Cursor
c        else if (key.eq.1119) then
c          text(1:laenge-i+1)=text(i:laenge)
c          text(laenge-i+2:laenge)=' '
c          i=1
cC  STRG-Ende: Lschen ab Cursor bis Textende
c        else if (key.eq.1117) then
c          text(i:laenge)=' '
cC  Einfgen mit INS/EINFG ein- oder auschalten
c        else if (key.eq.1082) then
c          if (insert) then
c            insert=.FALSE.
c          else
c            insert=.TRUE.
c          end if
cC  Sonstige 2-Byte-Tasten verhindern, auch Strg-F
c        else if (key.ge.1000.or.key.eq.6) then
c          goto 100
cC  Zuordnung des eingebebenen Zeichens zur Taste
c        else
cC  berschreiben
c          if (.not.insert) then
c            text(i:i)=char(key)
c            if (i.lt.laenge) i=i+1
c          end if
cC  Einfgen
c          if (insert) then
c            j=laenge-1
c            do while (j.ge.i)
c              text(j+1:j+1)=text(j:j)
c              j=j-1
c            end do
c            text(i:i)=char(key)
c            if (i.lt.laenge) i=i+1
c          end if
cC  Ende der Tastaturabfrage
c        end if
c      end do
c      end
C
C  Lesen der Daten aus den Unterverzeichnissen
C
      subroutine lesedaten (verz,files,sort,opt,datei,datum,zeit1,zeit2,
     *bytes,merkdate,marke,imax,zmax,hid,strgf9,isn,mkt,tab)
      integer*2 imax,j,nblank,marke,zmax,letzt,key,ixkey,i
      integer*2 zeit1(zmax),zeit2(zmax)
      integer bytes(zmax),by
      character *78 befehl
c     character *100 zeile
      character *48 zeile
      character *(*) datei(zmax)
      character *8 datum(zmax)
      character *9 byte
c     character *5 zeit(zmax)
      character *(*) verz,strgf9,files,merkdate,sort,opt
      character *12 upper
      character *2 tab
      character *1 mkt(zmax)
      logical hid,isn
c     logical dir

C  Befehl zum Einlesen der Dateinamen
C  Dateien aus aktuellem oder angegebenem Verzeichnis lesen
C  DOSWAHL: Option /-c verhindert Tausendertrennzeichen fr BYTES,
C  so dass diese als Integer eingelesen werden knnen
      if (.not.isn) then
c       write (*,*) '[2;',tab,'f Lese Verzeichnis ...'
        write (*,*) '[2;',tab,'f Lese ',verz(1:nblank(verz)),',',files
        befehl='dir'
        befehl(nblank(befehl)+2:)=files
        befehl(nblank(befehl)+1:)=sort
        befehl(nblank(befehl)+1:)=opt
        if (hid) befehl(nblank(befehl)+1:)='/ah'
        befehl(nblank(befehl)+1:)='/-p>C:\DIR.TMP'
        call system (befehl)
      end if
c     print *,befehl
c     call pause
C  Datei DIR.TMP ffnen
      imax=0
      open (13,file='C:\DIR.TMP',err=99)
      rewind (13)
C  Dateinamen lesen
C  ISN ist fr DIR erforderlich sonst funktioniert F3 (Dokumente)
C  in REKO-Programmauswahl nicht richtig
      i=1
10    read (13,'(A)',end=90) zeile
C  Um die tatschliche Dateianzahl anzeigen zu knnen
C  Das "i<0" ist fr den berlauf erforderlich, wenn i>32768
c     if (i.gt.zmax.or.i.lt.0) then
c       i=i+1
c       goto 10
c     end if
C  Ende beim Einlesen von mehr als der mglichen Dateianzahl
      if (i.gt.zmax) goto 90
C  Bestimmung des aktuellen Verzeichnisses aus DIR.TMP
      j=index(zeile,'\')
      if (j.gt.2.and.zeile(1:1).eq.' ') verz=zeile(j-2:)
C  Zeilen mit Leerzeichen am Anfang und "." ausblenden
      if (zeile(1:2).eq.'. '
c    *.or.zeile(1:15).eq.'Verzeichnis von'
c    *.or.zeile(1:12).eq.'Directory of'
     *.or.index(zeile,'Dateien:').gt.0
     *.or.index(zeile,'Total files').gt.0
     *.or.zeile(1:1).eq.' ') goto 10

C  Dateinamen lesen
C  Suchkriterium von STRG-F9 bercksichtigen
C  Neu: Dateiname auch mit CMD linksbndig,
C  daher fngt er in WinXP ab Spalte 37 und in Win2k ab Spalte 40 an
      if (strgf9.ne.' '.and.index(zeile,strgf9(1:nblank(strgf9))).gt.0
     *.or.strgf9.eq.' ') then

C  hiermit sollten nur alle markierten Dateien angezeigt werden,
C  das funktioniert aber nicht, daher deaktiviert
c    .or.strgf9.eq.'*'.and.mkt(i).eq.'*') then

C  Erforderlich fr REKOTEST, FINDEN, Alt-F7 in AUSWAHL
        if (index(zeile,'\').gt.0) then
          verz=' '
          verz=zeile(1:letzt(zeile,'\')-1)
        end if

C  Es wird der Dateiname ohne Punkt erstellt, muss also ergnzt werden
        datei(i)=zeile(1:9)
        if (zeile(10:12).ne.' ') then
          datei(i)(nblank(datei(i))+1:)='.'//zeile(10:12)
        end if
C  Fr die Option /s
C  Deaktiviert in DOSWAHL, 12 Zeichen gengen nicht.
c        if (opt.eq.'/s') then
c          befehl=verz
c          j=nblank(befehl)
c          if (befehl(j:j).ne.'\') befehl(j+1:)='\'
c          befehl(nblank(befehl)+1:)=datei(i)
c          datei(i)=befehl
c        end if

C  Fr DOSWAHL: Anzeige des Ordners als Datei
        if (opt.eq.'/s') then
          if(zeile(1:15).eq.'Verzeichnis von'
     *   .or.zeile(1:12).eq.'Directory of') then
            j=index(zeile,':\')
            datei(i)=zeile(j-1:)
          end if
        end if

C  Gre der Datei in Bytes
C  Windows 7: 14:22
C  DOS: enthlt Tausender-Trennzeichen ","
        bytes(i)=-1
        byte=' '
        if (index(zeile,'<DIR>').eq.0) then
          j=index(zeile,'-')
          if (j.gt.12) then
            byte=zeile(j-12:j-4)
            j=index(byte,',')
            if (j.gt.0) then
              read (byte(j-3:j-1),'(I3)') by
              bytes(i)=by*1000
              read (byte(j+1:j+3),'(I3)') by
              bytes(i)=bytes(i)+by
            end if
          else
            read (zeile(14:22),'(I9)',err=51) bytes(i)
          end if
51      end if

C  Datum der Datei
C  Windows 7: 24:31
        datum(i)=' '
        if (index(zeile,':\').eq.0) then
          j=index(zeile,'-')
          if (j.gt.12) then
            datum(i)=zeile(j-2:j+5)
          else
            datum(i)=zeile(24:31)
          end if
        end if

C  Suche nach der ZEIT ber das ":"
c       zeit(i)=zeile(35:39)
        j=index(zeile,':')
c       zeit(i)=zeile(j-2:j+2)
        zeit1(i)=0
        zeit2(i)=0
        if (j.gt.0) then
          read (zeile(j-2:j-1),'(I2)',err=52) zeit1(i)
          read (zeile(j+1:j+2),'(I2)',err=52) zeit2(i)
        end if
52      continue

C  Marker fr gemerkte Datei setzen
        if (merkdate.ne.' ') then
C  Datei(i) und MERKDATE kann Kleinbuchstaben enthalten, daher mit upper
c         if (datei(i).eq.merkdate) marke=i
C  entweder
c         if (upper(datei(i)).eq.upper(merkdate)) marke=i
C  oder: muss nicht identisch sein, ein enthlt gengt auch;
C  aus Kapazittsgrnden wird diese Variante nicht verwendet
          if (index(upper(datei(i)),upper(merkdate)).gt.0) marke=i
C  ende entweder
        end if
C  Fr Strg-*: Markierung setzen
        if (isn) mkt(i)='*'
C  Anzahl der eingelesenen Dateien/Verzeichnisse
        imax=i
        i=i+1
C  Ende-Strg-F9
      end if

C  Nchste Zeile/Datei
      goto 10
90    close (13)

C  Fehler: Anzahl
C  Das "i<0" ist fr den berlauf erforderlich, wenn i>32768
      if (i.gt.zmax.or.i.lt.0) then
        write (*,15) tab,zmax
15      format (' [2;',A2,'f Nur ',I4,' Dateien anzeigbar!')
c       call pause
        key=ixkey()
        key=key
        imax=zmax
      end if
      return

C  Fehler: lesen
99    close (13)
      write (*,*) ' Fehler: lesen der Verzeichnis-Datei C:\DIR.TMP'
      call pause
      imax=0
      return
      end
C
C  Umwandlung eines Strings von Klein- in Grobuchstaben.
C
C  Variablen-Definitionen und Deklarationen
C     STRING = zu bearbeitende Zeichenkette (string)
C     OUTPUT = auszugebende Zeichenkette
C     Z      = zu bearbeitendes Zeichen im string
C     NLEN   = Lnge (Anzahl der Zeichen) des string
C     J      = Position eines Zeichens im string
C     IZ     = ASCII-Codes eines Zeichens im string
C
      function upper(string)
      character *(*) string,upper
      integer*2 nblank,j,iz
C  Initialisierung, Lnge berechnen
      upper=' '
      j=1
C  Berechnung der Ausgabe
C  Kleinbuchstaben werden Grobuchstaben
      do while (j.le.nblank(string))
        iz=ichar(string(j:j))
        if (iz.ge.97.and.iz.le.122) iz=iz-32
        upper(j:j)=char(iz)
        j=j+1
      end do
      end
C
C  Pfad ermitteln (fr F8, Digitale Akte)
C  Version NUR fr DOSWAHL.FOR, NICHT fr AUSWAHL.FOR
C  Da JAHR bergeben wird muss es hier nicht ermittelt werden
C  (Wegen Kapazittsproblem)
C
      subroutine pfad (verz,fall,is,jahr)
      character *(*) verz,fall
      integer*2 jahr,nblank
      logical is,ok
C  Anfang: Text ist der Laufwerksbuchstabe
C  Jahr anhngen
C  Neue Flle (8-stellige Fallnummer)
      if (is) verz(nblank(verz)+1:)='\'
c     read (fall(3:4),'(I2)',err=10) jahr
      if (jahr.lt.73) verz(nblank(verz)+1:)='20'
      if (jahr.ge.73) verz(nblank(verz)+1:)='19'
10    verz(nblank(verz)+1:)=fall(3:4)//'\'
c  Fr Hannover (Region 30)
C  Fallnummernbereich, z.B. 30120100-30120199
      verz(nblank(verz)+1:)=fall(1:6)//'~1\'
C  Fallnummer anhngen
      verz(nblank(verz)+1:)=fall
C  Verzeichnis erstellen
      verz(nblank(verz)+1:)='\NUL'
      inquire (file=verz,exist=ok)
      verz(index(verz,'\NUL'):)=' '
      if (.not.ok) then
        call cls
        write (*,*)
     *  ' Fallordner ',verz(1:nblank(verz)),' fehlt, erstellen (J/N)?'
        call askjn (*99)
        call system ('md '//verz)
99    end if
C  Kontrollausgabe
c     print *,verz
c     call pause
C  Fertig
      return
      end
C
C  ANFTMP.BAT schreiben (fr ANFANG.BAT)
C
c      subroutine beginn (befehl)
c      character *(*) befehl
cc     integer*2 nblank
c      open (10,file='ANFTMP.BAT')
cc     write (10,'(A/A)') '@echo off',befehl(1:nblank(befehl))
c      write (10,'(A/A)') '@echo off',befehl
c      close (10)
c      stop
c      end
C
C  ?: Info
C
      subroutine info (zmax,dlaenge)
      integer*2 zmax,dlaenge
      call cls
      write (*,10) zmax,dlaenge
10    format ('  DOSWAHL.EXE'//,
     *'  Zweck    : Dateiauswahl fr die Rekonstruktions-Programme'/,
     *'  Dateien  : max. Anzahl:',I4,'; max. Namenslnge:',I3,/,
     *'  Parameter: Laufwerk:\Pfad\Dateikriterium  [Optionen]'//,
     *'  Optionen : '/,
c    *'  /0       : bei Start Laufwerksauswahl anzeigen'/,
     *'  /key:1103: bei Start Laufwerksauswahl anzeigen'/,
     *'  /1       : Farbe u. MODE CON LINES nicht ausfhren'/,
     *'  /2       : Dateiliste C:\DIR.TMP nur lesen'/,
     *'  /4       : nderungen an Dateien ist nicht erlaubt'/,
     *'  /5       : Fallnummer automatisch bercksichtigen'/,
c    *' [/8:xxx   : bei Ende den Befehl xxx aufrufen]'/,
c    *' [/sb      : Dateien in Unterverzeichnissen anzeigen]'/,
     *'  /s       : Dateien in Unterverzeichnissen anzeigen'/,
     *'  /F:xxx   : Bei Start nach Suchtext xxx suchen'/,
     *'  /key:x   : Bei Start die Taste key=xxxx ausfhren'//,
     *'  Autor    : Dipl.-Ing. (FH) Uwe Bhnke, Hannover'/,
     *'  Copyright: Uwe Jens Bhnke, Hannover'/,
     *'  Erstellt : 04.12.2014'/,
     *'  Stand    : 13.03.2024'/)
      call pause
      call cls
      return
      end
