C  FILTER
C  Autor   : Uwe Bhnke, Hannover
C  Erstellt: 01.12.2023
C  Stand   : 04.12.2023
C
C  Mit FOXIT READER wird aus der CODEBOOK.PDF eine Textdatei
C  als CODEBOOK.FOX erstellt.
C  Oder mit Adobe Reader 9.40 als Codebook.txt.
C
C  Dieses Programm liest die CODEBOOK.TXT,
C  sichert sie als *.org,
C  filtert die Leerzeilen heraus,
C  wandelt ANSI zu ASCII,
C  und speichert sie.
C  Diese kann dann von MACHHLF.EXE bearbeitet werden.
C
C  Der Acrobat Reader braucht zum Speichern mindestens 4 Stunden.
C  Der Foxit Reader braucht nur wenige Sekunden,
C  erzeugt aber Leerzeilen.
C  Word auch nur ein paar Sekunden, verschluckt aber Anfangszeichen.
C
      program filter
      character*256 text
      character*77 befehl
      character*12 datei,sicher
      integer*2 nblank,i
      logical ok
      datei=' '
      sicher=' '
      text=' '
      befehl=' '
C
      print *,' FILTER.EXE'
      print *,' Liest Datei, filtert Leerzeilen, wandelt in ASCII'
      write (*,*) ' Datei [CODEBOOK.TXT]:'
      read (*,'(A)') datei
      if (datei.eq.' ') datei='CODEBOOK.TXT'
      inquire (file=datei,exist=ok)
      if (.not.ok) goto 99
C
      sicher=datei
      i=index(datei,'.')
      if (i.gt.0) then
        sicher(i+1:)='ORG'
      else
        sicher(nblank(sicher)+1:)='.ORG'
      end if
      befehl='copy'
      befehl(6:)=datei
      befehl(nblank(befehl)+2:)=sicher
      print*, befehl
      call system (befehl)
C
      open (10,file=sicher,err=99)
      open (11,file=datei)
100   read (10,'(A)',end=200) text
      if (text.ne.' ') then
        call filterd (text,.false.)
        write (11,'(A)') text(1:nblank(text))
      end if
      goto 100
C
200   close (10)
      close (11)
      print *,' fertig'
      call pause
      stop
c
99    close (10)
      print *,' Datei nicht gefunden:',datei(1:nblank(datei))
      call pause
      stop
      end
C
C  Umwandlung ASCII-ANSI oder umgekehrt
C  FIL = TRUE : Umwandlung ASCII zu ANSI (fr WIN ist es das Richtige)
C  FIL = FALSE: Umwandlung ANSI zu ASCII (fr DOS ist es das Richtige)
C  FIL muss hier genau so definiert sein wie FILTER in REKO.INI!
C  FIL wird intern in REKOEDIT verwendet;
C  FILTER gibt an, ob beim Speichern nach ANSI umgewandelt werden soll
C
      subroutine filterd (text,fil)
      character *(*) text
      integer*2 nblank
      integer*2 k
      logical fil
      if (.not.fil) then
        k=1
        do while (k.le.nblank(text))
          if (text(k:k).eq.'') text(k:k)=''
          if (text(k:k).eq.'') text(k:k)=''
          if (text(k:k).eq.'') text(k:k)=''
          if (text(k:k).eq.'') text(k:k)=''
          if (text(k:k).eq.'') text(k:k)=''
          if (text(k:k).eq.'') text(k:k)=''
          if (text(k:k).eq.'') text(k:k)=''
          if (text(k:k).eq.'') text(k:k)=''
          if (text(k:k).eq.'') text(k:k)=''
c         if (text(k:k).eq.'') text(k:k)=''
          if (text(k:k).eq.'') text(k:k)=''
          k=k+1
        end do
      else
        k=1
        do while (k.le.nblank(text))
          if (text(k:k).eq.'') text(k:k)=''
          if (text(k:k).eq.'') text(k:k)=''
          if (text(k:k).eq.'') text(k:k)=''
          if (text(k:k).eq.'') text(k:k)=''
          if (text(k:k).eq.'') text(k:k)=''
          if (text(k:k).eq.'') text(k:k)=''
          if (text(k:k).eq.'') text(k:k)=''
          if (text(k:k).eq.'') text(k:k)=''
          if (text(k:k).eq.'') text(k:k)=''
c         if (text(k:k).eq.'') text(k:k)=''
          if (text(k:k).eq.'') text(k:k)=''
          k=k+1
        end do
      end if
      return
      end
